package Editor;

/**
 * This window is used to add, delete, and arrange the actions 
 * of a state or transition.  It's called by the Conversation Panel
 * Creation date: (2/17/00 4:09:55 PM)
 * @author: Jennifer Mifflin
  *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
 import java.util.Vector;
public class ActionPanel extends javax.swing.JDialog {
	//buttons to add, organize, edit, and delete actions
	private javax.swing.JButton ivjJButton1 = null; //add
	private javax.swing.JButton ivjJButton2 = null;	//move down
	private javax.swing.JButton ivjJButton3 = null;	//move up
	private javax.swing.JButton ivjJButton4 = null;	//edit
	private javax.swing.JButton ivjJButton5 = null;	//delete
	//button to close window and set actions
	private javax.swing.JButton ivjJButton6 = null;	//finish

	//content pane
	private javax.swing.JPanel ivjJFrameContentPane = null;
	//list that is shown to user
	private javax.swing.JList ivjJList1 = null;
	//scroll pane that houses ivjJList1
	private javax.swing.JScrollPane ivjJScrollPane1 = null;
	//used to edit and add actions
	private javax.swing.JTextField ivjJTextField1 = null;
	//label for ivjJTextField1
	private javax.swing.JLabel ivjJLabel1 = null;
	//list of the actions
	private Vector list = new Vector();
	//event handler
	IvjEventHandler ivjEventHandler = new IvjEventHandler();
	//true if the item in the text field is being edited
	private boolean edit = false;
	
	//state or transition that these actions belong to
	private system.ATstate state = null;
	private system.ATtransition tran = null;
	//whether the actions belong to a state or a transition
	private boolean State = false;
	
class IvjEventHandler implements java.awt.event.ActionListener {
		public void actionPerformed(java.awt.event.ActionEvent e) {
			if (e.getSource() == ActionPanel.this.getJButton1()) 
				connEtoC1();
			if (e.getSource() == ActionPanel.this.getJButton2()) 
				connEtoC2();
			if (e.getSource() == ActionPanel.this.getJButton3()) 
				connEtoC3();
			if (e.getSource() == ActionPanel.this.getJButton4()) 
				connEtoC4();
			if (e.getSource() == ActionPanel.this.getJButton5()) 
				connEtoC5();
			if (e.getSource() == ActionPanel.this.getJButton6()) 
				connEtoC6();
		};
	};
/**
 * ActionPanel constructor comment.
 */
public ActionPanel() {
	super();
	initialize();
}
/**
 * connEtoC1:  (JButton1.action. --> ActionPanel.jButton1_ActionEvents()V)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC1() {
	try {
		// user code begin {1}
		// user code end
		this.jButton1_ActionEvents();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoC2:  (JButton2.action. --> ActionPanel.jButton2_ActionEvents()V)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC2() {
	try {
		// user code begin {1}
		// user code end
		this.jButton2_ActionEvents();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoC3:  (JButton3.action. --> ActionPanel.jButton3_ActionEvents()V)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC3() {
	try {
		// user code begin {1}
		// user code end
		this.jButton3_ActionEvents();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoC4:  (JButton4.action. --> ActionPanel.jButton4_ActionEvents()V)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC4() {
	try {
		// user code begin {1}
		// user code end
		this.jButton4_ActionEvents();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoC5:  (JButton5.action. --> ActionPanel.jButton5_ActionEvents()V)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC5() {
	try {
		// user code begin {1}
		// user code end
		this.jButton5_ActionEvents();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoC6:  (JButton6.action. --> ActionPanel.jButton6_ActionEvents()V)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC6() {
	try {
		// user code begin {1}
		// user code end
		this.jButton6_ActionEvents();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * Return the JButton1 property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getJButton1() {
	if (ivjJButton1 == null) {
		try {
			ivjJButton1 = new javax.swing.JButton();
			ivjJButton1.setName("JButton1");
			ivjJButton1.setText("Add");
			ivjJButton1.setBounds(399, 311, 85, 27);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJButton1;
}
/**
 * Return the JButton2 property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getJButton2() {
	if (ivjJButton2 == null) {
		try {
			ivjJButton2 = new javax.swing.JButton();
			ivjJButton2.setName("JButton2");
			ivjJButton2.setText("Move Up");
			ivjJButton2.setBounds(72, 51, 106, 27);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJButton2;
}
/**
 * Return the JButton3 property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getJButton3() {
	if (ivjJButton3 == null) {
		try {
			ivjJButton3 = new javax.swing.JButton();
			ivjJButton3.setName("JButton3");
			ivjJButton3.setText("Move Down");
			ivjJButton3.setBounds(71, 96, 107, 27);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJButton3;
}
/**
 * Return the JButton4 property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getJButton4() {
	if (ivjJButton4 == null) {
		try {
			ivjJButton4 = new javax.swing.JButton();
			ivjJButton4.setName("JButton4");
			ivjJButton4.setText("Edit");
			ivjJButton4.setBounds(71, 183, 107, 27);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJButton4;
}
/**
 * Return the JButton5 property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getJButton5() {
	if (ivjJButton5 == null) {
		try {
			ivjJButton5 = new javax.swing.JButton();
			ivjJButton5.setName("JButton5");
			ivjJButton5.setText("Delete");
			ivjJButton5.setBounds(71, 233, 107, 27);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJButton5;
}
/**
 * Return the JButton6 property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getJButton6() {
	if (ivjJButton6 == null) {
		try {
			ivjJButton6 = new javax.swing.JButton();
			ivjJButton6.setName("JButton6");
			ivjJButton6.setText("Finish");
			ivjJButton6.setBounds(228, 354, 85, 27);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJButton6;
}
/**
 * Return the JFrameContentPane property value.
 * @return javax.swing.JPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JPanel getJFrameContentPane() {
	if (ivjJFrameContentPane == null) {
		try {
			ivjJFrameContentPane = new javax.swing.JPanel();
			ivjJFrameContentPane.setName("JFrameContentPane");
			ivjJFrameContentPane.setLayout(null);
			getJFrameContentPane().add(getJTextField1(), getJTextField1().getName());
			getJFrameContentPane().add(getJButton1(), getJButton1().getName());
			getJFrameContentPane().add(getJScrollPane1(), getJScrollPane1().getName());
			getJFrameContentPane().add(getJButton2(), getJButton2().getName());
			getJFrameContentPane().add(getJButton3(), getJButton3().getName());
			getJFrameContentPane().add(getJLabel1(), getJLabel1().getName());
			getJFrameContentPane().add(getJButton4(), getJButton4().getName());
			getJFrameContentPane().add(getJButton5(), getJButton5().getName());
			getJFrameContentPane().add(getJButton6(), getJButton6().getName());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJFrameContentPane;
}
/**
 * Return the JLabel1 property value.
 * @return javax.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JLabel getJLabel1() {
	if (ivjJLabel1 == null) {
		try {
			ivjJLabel1 = new javax.swing.JLabel();
			ivjJLabel1.setName("JLabel1");
			ivjJLabel1.setText("Action:");
			ivjJLabel1.setBounds(46, 292, 46, 17);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJLabel1;
}
/**
 * Return the JList1 property value.
 * @return javax.swing.JList
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JList getJList1() {
	if (ivjJList1 == null) {
		try {
			ivjJList1 = new javax.swing.JList();
			ivjJList1.setName("JList1");
			ivjJList1.setBounds(-10, 0, 167, 228);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJList1;
}
/**
 * Return the JScrollPane1 property value.
 * @return javax.swing.JScrollPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JScrollPane getJScrollPane1() {
	if (ivjJScrollPane1 == null) {
		try {
			ivjJScrollPane1 = new javax.swing.JScrollPane();
			ivjJScrollPane1.setName("JScrollPane1");
			ivjJScrollPane1.setBounds(237, 35, 249, 253);
			getJScrollPane1().setViewportView(getJList1());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJScrollPane1;
}
/**
 * Return the JTextField1 property value.
 * @return javax.swing.JTextField
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JTextField getJTextField1() {
	if (ivjJTextField1 == null) {
		try {
			ivjJTextField1 = new javax.swing.JTextField();
			ivjJTextField1.setName("JTextField1");
			ivjJTextField1.setBounds(44, 313, 316, 21);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJTextField1;
}
/**
 * Return the list property value.
 * @return java.util.Vector
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
public java.util.Vector getlist() {
	// user code begin {1}
	// user code end
	return list;
}
/**
 * Called whenever the part throws an exception.
 * @param exception java.lang.Throwable
 */
private void handleException(java.lang.Throwable exception) {

	/* Uncomment the following lines to print uncaught exceptions to stdout */
	// System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	// exception.printStackTrace(System.out);
}
/**
 * Initializes connections
 * @exception java.lang.Exception The exception description.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initConnections() throws java.lang.Exception {
	//add action listeners to buttons
	getJButton1().addActionListener(ivjEventHandler);
	getJButton2().addActionListener(ivjEventHandler);
	getJButton3().addActionListener(ivjEventHandler);
	getJButton4().addActionListener(ivjEventHandler);
	getJButton5().addActionListener(ivjEventHandler);
	getJButton6().addActionListener(ivjEventHandler);
}
/**
 * Initialize the class.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initialize() {
	try {
		// user code begin {1}
		// user code end
		setName("ActionPanel");
		setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		setSize(524, 439);
		setTitle("Action Panel");
		setContentPane(getJFrameContentPane());
		initConnections();
	} catch (java.lang.Throwable ivjExc) {
		handleException(ivjExc);
	}
	// user code begin {2}
	// user code end
}
/**
 * Comment
 */
public void jButton1_ActionEvents() {
	//get the name of new or edited action
	String name = getJTextField1().getText();
	if(edit == true){
		//it the action was being edited,
		//remove the old action
		int index = getJList1().getSelectedIndex();
		list.remove(index);
		//insert the new action in the same position
		list.insertElementAt(name,index);
		//set the list data and selected index
		getJList1().setListData(list);
		getJList1().setSelectedIndex(index);
		repaint();
	} else{
		//if it's a new action, add it to the list data
		list.addElement(name);
		getJList1().setListData(list);
	}
	//set edit to false
	edit = false;
	return;
}
/**
 * this will move actions in the list up one space
 */
public void jButton2_ActionEvents() {
	//get index of selected action
	int index = getJList1().getSelectedIndex();
	//if the choosen action is not the top one
	if(index>0){
		//remove the action at index
		String below = (String)list.remove(index);
		//insert the action at the index one above it's previous position
		list.insertElementAt(below,index-1);
		//set the JList to the new list
		getJList1().setListData(list);
		//set the selected index to the new location of the moved action
		getJList1().setSelectedIndex(index-1);
		repaint();
	}
	return;
}
/**
 * this will move a selected action down one position in the list
 */
public void jButton3_ActionEvents() {
	//get the index of the selected action
	int index = getJList1().getSelectedIndex();
	//if the selected action is not the last in the list
	if(index<list.size()-1){
		//remove the action at the index
		String below = (String)list.remove(index);
		//insert the action one place below it's previous location
		list.insertElementAt(below,index+1);
		//set the visible list's data
		getJList1().setListData(list);
		//set the selected index to the new location of the moved action
		getJList1().setSelectedIndex(index+1);
		repaint();
	}
	return;
}
/**
 * this is used for editing an action- it gets the name and places it in
 * the text box at the bottom of the window
 */
public void jButton4_ActionEvents() {
	//get index of selected action
	int index = getJList1().getSelectedIndex();
	//get the name of the element at the selected index
	String below = (String)list.elementAt(index);
	//set JTextField1's text to that name
	getJTextField1().setText(below);
	repaint();
	//set edit to true so when "Add" button is pushed it knows to put in
	//place of old action, not just add the action to the list
	edit = true;
	return;
}
/**
 * removes the selected action
 */
public void jButton5_ActionEvents() {
	//get the index of the selected action
	int index = getJList1().getSelectedIndex();
	//remove action at that index from the list
	String below = (String)list.remove(index);
	//reset JList1's data
	getJList1().setListData(list);
	repaint();
	return;
}
/**
 * this method looks to see if we are describing a state or a transition
 * and then accordingly sets that object's action to the current list
 * Then, the window closes.
 */
public void jButton6_ActionEvents() {
	//check to see if list describes a state or a transition, the set
	//action accordingly
	if(State){
		setState();
	} else {
		setTran();
	}
	//close window
	this.dispose();
	return;
}
/**
 * Set the list to a new value.
 * @param newValue java.util.Vector
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
public void setlist(java.util.Vector newValue) {
	if (list != newValue) {
		try {
		//	java.util.Vector oldValue = getlist();
			list = newValue;
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	// user code begin {3}
	// user code end
}
/**
 * Insert the method's description here.
 * Creation date: (2/24/00 10:23:31 AM)
 */
public void setState() {
	//set state's actions to list
	state.setActions(list);
}
/**
 * set's the state for the panel (ie- this panel list the actions
 * for state s)
 * Creation date: (2/24/00 10:23:31 AM)
 */
public void setState(system.ATtableElement s) {
	if(s.getName() != "StartState" && s.getName() != "EndState") {
		//set state to s
		state = (system.ATstate)s;
		//set State to true
		State = true;
		//set JList and list to the actions of state
		getJList1().setListData(state.getActions());
		setlist(state.getActions());
	}
}
/**
 * set's tran's actions to list
 * Creation date: (2/24/00 10:23:31 AM)
 */
public void setTran() {
	//set tran's actions to list
	tran.setAction(list);
}
/**
 * set's the transition for the panel (ie- this panel lists the actions
 * for transition t)
 * Creation date: (2/24/00 10:23:31 AM)
 */
public void setTran(system.ATtransition t) {
	//set tran to t
	tran = t;
	//set State to false (b/c it describes a transition, not a state)
	State = false;
	//set JLiset and list's data to t's actions
	getJList1().setListData(t.getActions());
	setlist(t.getActions());
	}
}
