package Editor;

import java.awt.*;
/**
 * This type was created in VisualAge.
  *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
public class FrameLayout implements LayoutManager {
	private final int tabbedPaneX = 150; // 113
	private final int tabbedPaneY = 40;	//85
/**
 * FrameLayout constructor comment.
 */
public FrameLayout() {
	super();
}
/**
 * addLayoutComponent method comment.
 */
public void addLayoutComponent(String name, Component comp) {
}
/**
 * layoutContainer method comment.
 */
public void layoutContainer(Container parent) {
	Insets insets = parent.getInsets();
	int containerWidth = parent.getSize().width - insets.left - insets.right;
	int containerHeight = parent.getSize().height - insets.top - insets.bottom;

	setSizes(parent);

	Component c = parent.getComponent(0);
	int c_width = containerWidth - tabbedPaneX;
	int c_height = containerHeight - tabbedPaneY;
	c.setBounds(tabbedPaneX,tabbedPaneY,c_width,c_height);
}
/**
 * minimumLayoutSize method comment.
 */
public Dimension minimumLayoutSize(Container parent) {
	return null;
}
/**
 * preferredLayoutSize method comment.
 */
public Dimension preferredLayoutSize(Container parent) {
	return null;
}
/**
 * removeLayoutComponent method comment.
 */
public void removeLayoutComponent(Component comp) {
}
/**
 * This method was created in VisualAge.
 * @param parent java.awt.Container
 */
public void setSizes(Container parent) {
}
}
