package Editor;

/**
 * Insert the type's description here.
 * Creation date: (5/18/00 10:44:32 AM)
 * Window to allow Roles to be added to an agent
 * @author: Jennifer Mifflin
  *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
 import java.util.*;
 import system.*;
public class RoleWindow extends javax.swing.JDialog {
	
	private javax.swing.JButton ivjAddRoleButton = null;
	private javax.swing.JButton ivjDeleteRoleButton = null;
	private javax.swing.JButton ivjFinishButton = null;
	
	private javax.swing.JList ivjAgentsRoles = null;
	
	private javax.swing.JPanel ivjJFrameContentPane = null;
	
	private javax.swing.JLabel ivjJLabel1 = null;
	private javax.swing.JLabel ivjJLabel2 = null;
	
	private javax.swing.JScrollPane ivjJScrollPane1 = null;
	private javax.swing.JScrollPane ivjJScrollPane2 = null;
	
	private javax.swing.JList ivjRoles = null;
	
	private java.util.Vector list1 = null;
	private java.util.Vector list2 = null;
	
	IvjEventHandler ivjEventHandler = new IvjEventHandler();
	
	system.ATagent agent = null;
	system.ATRole role = null;

	class IvjEventHandler implements java.awt.event.ActionListener {
		public void actionPerformed(java.awt.event.ActionEvent e) {
			if (e.getSource() == RoleWindow.this.getAddRoleButton()) 
				connEtoC1();
			if (e.getSource() == RoleWindow.this.getDeleteRoleButton()) 
				connEtoC2();
			if (e.getSource() == RoleWindow.this.getFinishButton()) 
				connEtoC3();
		};
	};
/**
 * RoleWindow constructor comment.
 */
public RoleWindow(Vector roles, system.ATagent a) {
	super((java.awt.Frame)null,true);
	agent = a;
	list1 = new Vector();
	list2 = new Vector();
	setlist2(agent.getRoles());
	setlist1(roles);
	initialize();
}
/**
 * Insert the method's description here.
 * Creation date: (6/6/00 12:07:58 PM)
 */
public RoleWindow(Vector goals, system.ATRole r) {
	super((java.awt.Frame)null,true);
	role = r;
	list1 = new Vector();
	list2 = new Vector();
	setlist2(r.getGoals());
	setlist1(goals);
	initialize();
}
/**
 * Comment
 */
public void addRoleButton_ActionEvents() {
	int index = ivjRoles.getSelectedIndex();
	//Vector list = list2;
	//if(list2 == null){
	//	list = new Vector();
	//}
	if(agent!=null){
		((system.ATRole)(list1.elementAt(index))).addAgent(agent);
	}
	if(role!=null){
		((system.ATGoal)(list1.elementAt(index))).setRole(role);
	}
	
	list2.add(list1.elementAt(index));
	list1.removeElementAt(index);
	updateLists();
	
	//setlist1(list1);
	//setlist2(list);
//	getAgentsRoles().setListData(list2);
	return;
}
/**
 * connEtoC1:  (AddRoleButton.action. --> RoleWindow.addRoleButton_ActionEvents()V)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC1() {
	try {
		// user code begin {1}
		// user code end
		this.addRoleButton_ActionEvents();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoC2:  (DeleteRoleButton.action. --> RoleWindow.deleteRoleButton_ActionEvents()V)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC2() {
	try {
		// user code begin {1}
		// user code end
		this.deleteRoleButton_ActionEvents();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoC3:  (FinishButton.action. --> RoleWindow.finishButton_ActionEvents()V)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC3() {
	try {
		// user code begin {1}
		// user code end
		this.finishButton_ActionEvents();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * Comment
 */
public void deleteRoleButton_ActionEvents() {
	int index = getAgentsRoles().getSelectedIndex();
	//Vector list = list2;
	
	if(agent!=null){
		system.ATRole role = (system.ATRole)list2.elementAt(index);
		role.removeAgent(agent);
	}
	if(role!=null){
		system.ATGoal goal = (system.ATGoal)list2.elementAt(index);
		goal.removeRole();
	}
	list1.add(list2.elementAt(index));
	list2.removeElementAt(index);
	updateLists();
	//setlist1(list1);
	//setlist2(list);
//	getAgentsRoles().setListData(list2);
	return;
}
/**
 * Comment
 */
public void finishButton_ActionEvents() {
	if(list2!=null){
		if(agent!=null){
			agent.setRoles((Vector)list2.clone());
		}
		if(role!=null){
			role.setGoals((Vector)list2.clone());
		}
	}
	this.dispose();
	
	return;
}
/**
 * Return the AddRoleButton property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getAddRoleButton() {
	if (ivjAddRoleButton == null) {
		try {
			ivjAddRoleButton = new javax.swing.JButton();
			ivjAddRoleButton.setName("AddRoleButton");
			ivjAddRoleButton.setText("=> Add  =>");
			ivjAddRoleButton.setBounds(210, 113, 97, 27);
			ivjAddRoleButton.setActionCommand("AddRole");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjAddRoleButton;
}
/**
 * Return the AgentsRoles property value.
 * @return javax.swing.JList
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JList getAgentsRoles() {
	if (ivjAgentsRoles == null) {
		try {
			ivjAgentsRoles = new javax.swing.JList();
			ivjAgentsRoles.setName("AgentsRoles");
			ivjAgentsRoles.setBounds(0, 0, 160, 120);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjAgentsRoles;
}
/**
 * Return the DeleteRoleButton property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getDeleteRoleButton() {
	if (ivjDeleteRoleButton == null) {
		try {
			ivjDeleteRoleButton = new javax.swing.JButton();
			ivjDeleteRoleButton.setName("DeleteRoleButton");
			ivjDeleteRoleButton.setText("<= Delete <=");
			ivjDeleteRoleButton.setBounds(210, 155, 97, 27);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjDeleteRoleButton;
}
/**
 * Return the FinishButton property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getFinishButton() {
	if (ivjFinishButton == null) {
		try {
			ivjFinishButton = new javax.swing.JButton();
			ivjFinishButton.setName("FinishButton");
			ivjFinishButton.setText("Finish");
			ivjFinishButton.setBounds(210, 303, 97, 27);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjFinishButton;
}
/**
 * Return the JFrameContentPane property value.
 * @return javax.swing.JPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JPanel getJFrameContentPane() {
	if (ivjJFrameContentPane == null) {
		try {
			ivjJFrameContentPane = new javax.swing.JPanel();
			ivjJFrameContentPane.setName("JFrameContentPane");
			ivjJFrameContentPane.setLayout(null);
			getJFrameContentPane().add(getJScrollPane1(), getJScrollPane1().getName());
			getJFrameContentPane().add(getJScrollPane2(), getJScrollPane2().getName());
			getJFrameContentPane().add(getAddRoleButton(), getAddRoleButton().getName());
			getJFrameContentPane().add(getJLabel1(), getJLabel1().getName());
			getJFrameContentPane().add(getJLabel2(), getJLabel2().getName());
			getJFrameContentPane().add(getDeleteRoleButton(), getDeleteRoleButton().getName());
			getJFrameContentPane().add(getFinishButton(), getFinishButton().getName());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJFrameContentPane;
}
/**
 * Return the JLabel1 property value.
 * @return javax.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JLabel getJLabel1() {
	if (ivjJLabel1 == null) {
		try {
			ivjJLabel1 = new javax.swing.JLabel();
			ivjJLabel1.setName("JLabel1");
			if(role==null){
				ivjJLabel1.setText("Roles");
			} else {
				ivjJLabel1.setText("Goals");
			}
			ivjJLabel1.setBounds(34, 30, 146, 17);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJLabel1;
}
/**
 * Return the JLabel2 property value.
 * @return javax.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JLabel getJLabel2() {
	if (ivjJLabel2 == null) {
		try {
			ivjJLabel2 = new javax.swing.JLabel();
			ivjJLabel2.setName("JLabel2");
			if(role==null){
				ivjJLabel2.setText("Agent\'s Roles");
			} else {
				ivjJLabel2.setText("Role\'s Goals");
			}
			ivjJLabel2.setBounds(327, 30, 104, 17);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJLabel2;
}
/**
 * Return the JScrollPane1 property value.
 * @return javax.swing.JScrollPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JScrollPane getJScrollPane1() {
	if (ivjJScrollPane1 == null) {
		try {
			ivjJScrollPane1 = new javax.swing.JScrollPane();
			ivjJScrollPane1.setName("JScrollPane1");
			ivjJScrollPane1.setBounds(33, 55, 160, 275);
			ivjJScrollPane1.setViewportView(getRoles());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJScrollPane1;
}
/**
 * Return the JScrollPane2 property value.
 * @return javax.swing.JScrollPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JScrollPane getJScrollPane2() {
	if (ivjJScrollPane2 == null) {
		try {
			ivjJScrollPane2 = new javax.swing.JScrollPane();
			ivjJScrollPane2.setName("JScrollPane2");
			ivjJScrollPane2.setBounds(324, 55, 160, 275);
			ivjJScrollPane2.setViewportView(getAgentsRoles());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJScrollPane2;
}
/**
 * Return the Roles property value.
 * @return javax.swing.JList
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JList getRoles() {
	if (ivjRoles == null) {
		try {
			ivjRoles = new javax.swing.JList();
			ivjRoles.setName("Roles");
			ivjRoles.setBounds(0, 0, 157, 272);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjRoles;
}
/**
 * Called whenever the part throws an exception.
 * @param exception java.lang.Throwable
 */
private void handleException(java.lang.Throwable exception) {

	/* Uncomment the following lines to print uncaught exceptions to stdout */
	// System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	// exception.printStackTrace(System.out);
}
/**
 * Initializes connections
 * @exception java.lang.Exception The exception description.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initConnections() throws java.lang.Exception {
	// user code begin {1}
	// user code end
	getAddRoleButton().addActionListener(ivjEventHandler);
	getDeleteRoleButton().addActionListener(ivjEventHandler);
	getFinishButton().addActionListener(ivjEventHandler);
}
/**
 * Initialize the class.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initialize() {
	try {
		// user code begin {1}
		// user code end
		if(role==null){
			setName("RoleWindow");
			setTitle("Agent\'s Roles");
		} else {
			setName("GoalWindow");
			setTitle("Role\'s Goals");
		}
		setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		setSize(523, 385);
		setContentPane(getJFrameContentPane());
		initConnections();
		
	} catch (java.lang.Throwable ivjExc) {
		handleException(ivjExc);
	}
	// user code begin {2}
	// user code end
}
/**
 * Insert the method's description here.
 * Creation date: (5/18/00 12:03:57 PM)
 * @param agent system.ATagent
 */
public void setAgent(system.ATagent a) {
	agent = a;
	if(a.getRoles() != null){
		setlist2(a.getRoles());
	}
}
/**
 * Set the list to a new value.
 * @param newValue java.util.Vector
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
public void setlist1(java.util.Vector newValue) {
	try {
	//	list1 = newValue;
		java.util.Enumeration temp = newValue.elements();
		Vector list = new Vector();
		while(temp.hasMoreElements()){
			String s;
			if(agent!=null){
				ATRole hold = (system.ATRole)temp.nextElement();
				if(!list2.contains(hold)) {
					list1.add(hold);
					s = hold.getName();
					list.add(s);
				}
			} else {
				ATGoal goal = (system.ATGoal)temp.nextElement();
				if(!goal.hasRole() && !goal.getPartition() && !list2.contains(goal)){
					list1.add(goal);
					s = goal.getNum() + ". " + goal.getDescription();
					list.add(s);
				}
			}
			
		//	list.add(s);
		}
		getRoles().setListData(list);
		// user code begin {1}
			// user code end
	} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
		handleException(ivjExc);
	}
	// user code begin {3}
	// user code end
}
/**
 * Set the list to a new value.
 * @param newValue java.util.Vector
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
public void setlist2(java.util.Vector newValue) {
	try {
		list2 = (Vector)newValue.clone();
		java.util.Enumeration temp = list2.elements();
		Vector list = new Vector();
		while(temp.hasMoreElements()){
			String s;
			if(agent!=null){
				s = ((system.ATRole)(temp.nextElement())).getName();
			} else {
				ATGoal g = (ATGoal)temp.nextElement();
				s = g.getNum() + ". " + g.getDescription();
			}
			list.add(s);
		}
	//	java.util.Vector oldValue = getlist();
		getAgentsRoles().setListData(list);
		// user code begin {1}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {2}
		// user code end
		handleException(ivjExc);
	}
	// user code begin {3}
	// user code end
}
/**
 * Insert the method's description here.
 * Creation date: (5/18/00 12:03:57 PM)
 * @param agent system.ATagent
 */
public void setRole(system.ATRole r) {
	role = r;
	if(r.getGoals() != null){
		setlist2(r.getGoals());
	}
}
/**
 * Insert the method's description here.
 * Creation date: (11/7/00 12:35:41 PM)
 */
public void updateLists() {
	java.util.Enumeration temp = list1.elements();
	Vector list = new Vector();
	while(temp.hasMoreElements()){
		String s;
		if(agent!=null){
			s = ((system.ATRole)(temp.nextElement())).getName();
		} else {
			ATGoal g = (ATGoal)temp.nextElement();
			s = g.getNum() + ". " + g.getDescription();
		}
		list.add(s);
	}
	getRoles().setListData(list);
	
	temp = list2.elements();
	list = new Vector();
	while(temp.hasMoreElements()){
		String s;
		if(agent!=null){
			s = ((system.ATRole)(temp.nextElement())).getName();
		} else {
			ATGoal g = (ATGoal)temp.nextElement();
			s = g.getNum() + ". " + g.getDescription();
		}
		list.add(s);
	}
	getAgentsRoles().setListData(list);
}
}
