package Editor;

/**
 * Insert the type's description here.
 * Creation date: (6/16/00 8:41:09 AM)
 * Used in Deployment Panel to add an Agent Instance
 * user selects an agent and then the instance is added
 * @author: Jennifer Mifflin
  *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
 import java.util.*;
 import system.*;
public class SelectAgent extends javax.swing.JDialog {
	
	IvjEventHandler ivjEventHandler = new IvjEventHandler();
	
	private javax.swing.JButton ivjCancelButton = null;
	private javax.swing.JButton ivjSelectButton = null;
	
	private javax.swing.JPanel ivjJFrameContentPane = null;
	
	private javax.swing.JScrollPane ivjJScrollPane1 = null;
	
	private javax.swing.JLabel ivjAgentLabel = null;
	
	private javax.swing.JList ivjAgentList = null;
	
	private Vector agents;

	public static final String UNNAMED = "Unnamed Agent ";
	
	ATsystem sys;
	
	double version;


	class IvjEventHandler implements java.awt.event.ActionListener {
		public void actionPerformed(java.awt.event.ActionEvent e) {
			if (e.getSource() == SelectAgent.this.getSelectButton()) 
				connEtoC1();
			if (e.getSource() == SelectAgent.this.getCancelButton()) 
				connEtoC3();
		};
	};
/**
 * SelectRole constructor comment.
 */
public SelectAgent(Vector agents, ATsystem sys, double v) {
	super((java.awt.Frame)null,true);
	//super();
	this.agents = agents;
	this.sys = sys;
	version = v;
	initialize();
	Enumeration a = agents.elements();
	ATagent agent;
	Vector names = new Vector();
	while(a.hasMoreElements()){
		agent = (ATagent)a.nextElement();
		names.addElement(agent.getName());
	}
		
	getAgentList().setListData(names);
}
/**
 * Comment
 */
public void cancelButton_ActionEvents() {
	this.dispose();
	return;
}
/**
 * connEtoC1:  (SelectButton.action. --> SelectRole.selectButton_ActionEvents()V)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC1() {
	try {
		// user code begin {1}
		// user code end
		this.selectButton_ActionEvents();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoC3:  (CancelButton.action. --> SelectRole.cancelButton_ActionEvents()V)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC3() {
	try {
		// user code begin {1}
		// user code end
		this.cancelButton_ActionEvents();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * Return the AgentLabel property value.
 * @return javax.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JLabel getAgentLabel() {
	if (ivjAgentLabel == null) {
		try {
			ivjAgentLabel = new javax.swing.JLabel();
			ivjAgentLabel.setName("AgentLabel");
			ivjAgentLabel.setText("Agent Templates");
			ivjAgentLabel.setBounds(24, 22, 100, 17);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjAgentLabel;
}
/**
 * Return the RoleList property value.
 * @return javax.swing.JList
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JList getAgentList() {
	if (ivjAgentList == null) {
		try {
			ivjAgentList = new javax.swing.JList();
			ivjAgentList.setName("AgentList");
			ivjAgentList.setBounds(0, 0, 181, 132);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjAgentList;
}
/**
 * Return the CancelButton property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getCancelButton() {
	if (ivjCancelButton == null) {
		try {
			ivjCancelButton = new javax.swing.JButton();
			ivjCancelButton.setName("CancelButton");
			ivjCancelButton.setText("Cancel");
			ivjCancelButton.setBounds(250, 94, 100, 27);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjCancelButton;
}
/**
 * Return the JFrameContentPane property value.
 * @return javax.swing.JPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JPanel getJFrameContentPane() {
	if (ivjJFrameContentPane == null) {
		try {
			ivjJFrameContentPane = new javax.swing.JPanel();
			ivjJFrameContentPane.setName("JFrameContentPane");
			ivjJFrameContentPane.setLayout(null);
			getJFrameContentPane().add(getJScrollPane1(), getJScrollPane1().getName());
			getJFrameContentPane().add(getAgentLabel(), getAgentLabel().getName());
			getJFrameContentPane().add(getSelectButton(), getSelectButton().getName());
			getJFrameContentPane().add(getCancelButton(), getCancelButton().getName());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJFrameContentPane;
}
/**
 * Return the JScrollPane1 property value.
 * @return javax.swing.JScrollPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JScrollPane getJScrollPane1() {
	if (ivjJScrollPane1 == null) {
		try {
			ivjJScrollPane1 = new javax.swing.JScrollPane();
			ivjJScrollPane1.setName("JScrollPane1");
			ivjJScrollPane1.setBounds(22, 39, 186, 181);
			getJScrollPane1().setViewportView(getAgentList());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJScrollPane1;
}
/**
 * Return the SelectButton property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getSelectButton() {
	if (ivjSelectButton == null) {
		try {
			ivjSelectButton = new javax.swing.JButton();
			ivjSelectButton.setName("SelectButton");
			ivjSelectButton.setText("Select");
			ivjSelectButton.setBounds(250, 46, 100, 27);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjSelectButton;
}
/**
 * Called whenever the part throws an exception.
 * @param exception java.lang.Throwable
 */
private void handleException(java.lang.Throwable exception) {

	/* Uncomment the following lines to print uncaught exceptions to stdout */
	// System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	// exception.printStackTrace(System.out);
}
/**
 * Initializes connections
 * @exception java.lang.Exception The exception description.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initConnections() throws java.lang.Exception {
	// user code begin {1}
	// user code end
	getSelectButton().addActionListener(ivjEventHandler);
	getCancelButton().addActionListener(ivjEventHandler);
}
/**
 * Initialize the class.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initialize() {
	try {
		// user code begin {1}
		// user code end
		setName("SelectRole");
		setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		setSize(390, 275);
		setContentPane(getJFrameContentPane());
		initConnections();
	} catch (java.lang.Throwable ivjExc) {
		handleException(ivjExc);
	}
	// user code begin {2}
	// user code end
}
/**
 * Comment
 */
public void selectButton_ActionEvents() {
	int index = getAgentList().getSelectedIndex();
	if(index > -1){
		ATagent nextAgent = (ATagent)agents.elementAt(index);
		ATagent2 agent2 = new ATagent2(version, sys.getNextKey(), sys.getAgentInstanceCount());
		agent2.setAgent(nextAgent);
		int num = sys.getAgentInstanceCount();
		agent2.setName(UNNAMED + (num+1));
		sys.addAgentInstance(agent2);
		this.dispose();
	}
	return;
}
}
