package Transforms;

/**
 * This class is used to represent parameters used in FunctionCalls and Events
 *
 * Creation date: (11/3/00 10:50:21 AM)
 * @author: Clint Sparkman
 *
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */

import java.util.Vector;
 
public class Parameter {
	private String	name = null;			// parameter name
/**
 * Insert the method's description here.
 * Creation date: (11/5/00 1:34:11 AM)
 */
public Parameter(String n) {
	name = n;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 9:00:36 PM)
 * @return java.lang.String
 */
public java.lang.String getName() {
	return name;
}
/**
 * This method will return true if the first part of the parameter's
 * name is "parent."
 *
 * Creation date: (1/18/01 2:54:58 PM)
 */
public boolean isPrepended() {
	if((name != null) && name.startsWith("parent."))
		return true;
	return false;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 9:00:36 PM)
 * @param newName java.lang.String
 */
public void setName(java.lang.String newName) {
	name = newName;
}
/**
 * Returns a string that is the name of the parameter
 *
 * Creation date: (11/7/00 12:17:00 PM)
 */
public String toString() {
	return name;
}
}
