package Verify;

/**
 * A Class for converting logical operators &&, ||, and ! to AND, OR, and NOT
 * @version 1.0 6 Oct 1999
 * @author Capt Tim Lacey
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
public class ConvertLogic
{
/**
 * Converts logical operators to equivalent words
 * @param the input string with logical characters 
 * @return the converted string with logical words instead of logical characters
 * @throws nothing
 */
public static String convert(String newS)
{
	// Variable used to convert && to AND
	String tempString = "";
	// for the length of the input word...
	for (int i = 2; i<= newS.length(); i++)
	{
		// If 2 of the characters together equals &&...
		if (newS.substring(i-2,i).equals("&&"))
		{
			System.out.println("newS = "+newS);
			System.out.println("Found &&");
			// Then replace the && with AND
			tempString = newS.substring(0,i-2)+"AND"+newS.substring(i,newS.length());
			System.out.println("newS = "+tempString);
			// Reset the value of newS with the updated value
			newS = tempString;
		}
	}
	// Set the value of the temp variable to null to start over fresh
	tempString = null;
	// for the length of the input word...
	for (int i = 2; i<= newS.length(); i++)
	{
		// If 2 of the characters together equals ||...
		if (newS.substring(i-2,i).equals("||"))
		{
			System.out.println("newS = "+newS);
			System.out.println("Found ||");
			// Then replace the || with OR
			tempString = newS.substring(0,i-2)+"OR"+newS.substring(i,newS.length());
			System.out.println("newS = "+tempString);
			// Reset the value of newS with the updated value
			newS = tempString;
		}
	}
	// Set the value of the temp variable to null to start over fresh
	tempString = null;
	// for the length of the input word...
	for (int i = 1; i<= newS.length(); i++)
	{
		// If 1 of the characters equals !...
		if (newS.substring(i-1,i).equals("!"))
		{
			System.out.println("newS = "+newS);
			System.out.println("Found !");
			// Then replace the ! with NOT
			tempString = newS.substring(0,i-1)+"NOT"+newS.substring(i,newS.length());
			System.out.println("newS = "+tempString);
			// Reset the value of newS with the updated value
			newS = tempString;
		}
	}
	// Set the value of the temp variable to null to start over fresh
	tempString = null;
	return newS;
}
}
