package agentBase;

import java.util.*;
/**
 * This type was created in VisualAge.
 *
 * It defines a general purpose conversation to reply "Sorry"
 * to any unknown type of conversation.
 *
 */
import java.net.*;
import java.io.*;
import afit.mom.*;
import javax.swing.*;

public class CAList extends Conversation
{
	protected ConnectionAgent parent; // override parent
	public JFrame CG;
	private String objecttype = null;
	LoadGUI gui = null;
/**
 * Server_Register constructor comment.
 */
public CAList(ConnectionAgent a, String destinationName, int destinationPort, String s, JFrame graphical)
{
	super(a, destinationName, destinationPort);
	parent = a;
 	objecttype = s;
	gui =  (LoadGUI) graphical;
}
/**
 * This method was created in VisualAge.
 */
public void run()
{
	int state = 0;
	boolean notDone = true;
	Message m= new Message();

	
	//set up conversation
	try
	{
		System.out.println(" ** Creating Socket.");
		connection = new Socket(connectionHost, connectionPort);
		System.out.println(" ** Establishing output stream.");
		output = new ObjectOutputStream(connection.getOutputStream());
		output.flush();
		input = new ObjectInputStream(connection.getInputStream());
		String s = null;
		while (notDone)
		{
			switch (state)
			{
				case 0 :
					System.out.println(" ** Building message.");
					m.setContent(objecttype);
					m.setPerformative("list");
					System.out.println(" ** Sending message.");
					sendMessage(m, output);
					state = 1;
					break;
				case 1 :
					System.out.println(" ** Waiting for response message.");
					m = readMessage(input);
					System.out.println(" ** Received response message.");
					if (m.performative.equals("listerror")){
						s ="";
					}
					else {
						s = "";
						Set x = (Set)m.getContent();
						gui.setList(x);
					}
					//gui.setFeedback(s);	
					notDone = false;
					break;
			}
		}
		input.close();
		output.close();
		connection.close();
	}
	catch (UnknownHostException e)
	{
		System.out.println(" ** Unknown Host exception.");
	}
	catch (EOFException oef)
	{
		System.out.println(" ** Server terminated connection.");
	}
	catch (IOException e)
	{
		System.out.println(" ** IO Exception.");
		e.printStackTrace();
	}
}
}
