package agentBase;

/**
 * This type was created in VisualAge.
 *
 * It defines a general purpose conversation to reply "Sorry"
 * to any unknown type of conversation.
 *
 */
import java.net.*;
import java.io.*;
import afit.mom.*;
import javax.swing.*;

public class CALoadObject extends Conversation
{
	protected ConnectionAgent parent; // override parent
	public JFrame CG;
	private ATKB_Object k = null;
	LoadGUI gui = null;
/**
 * Server_Register constructor comment.
 */
public CALoadObject(ConnectionAgent a, String destinationName, int destinationPort, ATKB_Object item, JFrame graphical)
{
	super(a, destinationName, destinationPort);
	parent = a;
 	k = item;
	gui =  (LoadGUI) graphical;
}
/**
 * This method was created in VisualAge.
 */
public void run()
{
	int state = 0;
	boolean notDone = true;
	Message m= new Message();

	
	//set up conversation
	try
	{
		System.out.println(" ** Creating Socket.");
		connection = new Socket(connectionHost, connectionPort);
		System.out.println(" ** Establishing output stream.");
		output = new ObjectOutputStream(connection.getOutputStream());
		output.flush();
		input = new ObjectInputStream(connection.getInputStream());
		String s = null;
		while (notDone)
		{
			switch (state)
			{
				case 0 :
					System.out.println(" ** Buiding load message.");
					m.setContent(k);
					m.setPerformative("load");
					System.out.println(" ** Sending load message.");
					sendMessage(m, output);
					state = 1;
					break;
				case 1 :
					System.out.println(" ** Waiting for load response message.");
					m = readMessage(input);
					System.out.println(" ** Received response message.");
					if (m.performative.equals("loaderror")){
						s ="This key was not found.";
						//gui.receiveLoad((system.ATobject)m.getContent());
					}
					else {
						s = "AT_Object successfully loaded.";
						gui.receiveLoad((ATKB_Object)m.getContent());
					}
			//		gui.setFeedback(s);	
					notDone = false;
					break;
			}
		}
		input.close();
		output.close();
		connection.close();
	}
	catch (UnknownHostException e)
	{
		System.out.println(" ** Unknown Host exception.");
	}
	catch (EOFException oef)
	{
		System.out.println(" ** Server terminated connection.");
	}
	catch (IOException e)
	{
		System.out.println(" ** IO Exception.");
		e.printStackTrace();
	}
}
}
