package system;

/**
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
 import java.awt.*;
public class ATTaskGRFX extends Circle {
	String name = "";
	int Max = 50;
/**
 * ATtransitionGRFX constructor comment.
 */
public ATTaskGRFX() {
	super();
	set(100,100);
}
/**
 * ATtransitionGRFX constructor comment.
 */
public ATTaskGRFX(ATTaskGRFX cp) {
	super(cp);
}
/**
 * Insert the method's description here.
 * Creation date: (5/17/00 11:44:56 AM)
 * @param x int
 * @param y int
 */
public boolean dist(int x, int y) {
	int dx;
	int dy;
	if(x>center_x){
		dx = x - center_x;
	} else {
		dx = center_x - x;
	}
	if(y>center_y){
		dy = y-center_y;
	} else {
		dy = center_y - y;
	}
	if(dx < width/2){
		if(dy < height/2){
			return true;
		}
	}
	return false;
}
public void drawError(Graphics g) {
	g.setColor(Color.yellow);
	g.fillOval(x1-5, y1-5, height+10, width+10);
		
}
/**
 * This method was created in VisualAge.
 * @param g Graphics
 */
public void drawObject(Graphics g) {
	
	Font f = g.getFont();
	//FontMetrics fm = Toolkit.getDefaultToolkit().getFontMetrics(f);
	FontMetrics fm = g.getFontMetrics(); // SAD Change - deprecated fix???
	width = Max;
	int textWidth = fm.stringWidth(name);
	if((textWidth+7)>width){
		width = textWidth+8;
		Max = width;
	}
	
	g.setColor(new java.awt.Color(251,255,251));
	g.fillOval(center_x-(width/2),center_y-(height/2),width,height);

	g.setColor(new java.awt.Color(40,122,40)); 	// green
	g.drawOval(center_x-(width/2),center_y-(height/2),width,height);// draws the filled circle

	g.setColor(Color.black);
	g.drawString(name, center_x- textWidth/2, center_y + 5);
}
/**
 * This method was created in VisualAge.
 * @param g java.awt.Graphics
 */
public void drawSelected(Graphics g) {
	g.setColor(new java.awt.Color(255,110,20));
	g.drawOval(center_x-width/2-1,center_y-(height/2)-1,width+2,height+2);
//	g.drawOval(x1-1, y1-1, height+1, width+1);
		
}
/**
 * This method was created in VisualAge.
 * @param g Graphics
 */
public void paint(Graphics g) {
	g.setColor(new Color(0,150,0)); 	// green
	g.fillOval(x1+75,y1+75,height,width);		// draws the filled circle
}
/**
 * Insert the method's description here.
 * Creation date: (5/19/00 12:14:12 PM)
 */
public void resetMax() {
	Max = 50;
	}
}
