package system;

/**
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
//___________________________________________________
// Class to represent a line
//___________________________________________________
import java.io.*;
import java.util.*;
import java.awt.*;

class ATagent2GRFX extends Square {
	
	//Labels for square
	String name = "", aName = "";
	int Max = 60, MaxH = 60;
	int center;
/**
 * This method was created in VisualAge.
 */
public ATagent2GRFX() {
	super();
}
/**
 * This method was created in VisualAge.
 */
public ATagent2GRFX(ATagent2GRFX cp) {
	super(cp);
}
	//- - - - - - - - -
	// Draw a blue line
	//- - - - - - - - -
public void drawObject(java.awt.Graphics g) {
	String s = name;
	String s2 =  "{" + aName + "}";
	Font f = g.getFont();
	//FontMetrics fm = Toolkit.getDefaultToolkit().getFontMetrics(f);
	FontMetrics fm = g.getFontMetrics(); // SAD Change - deprecated fix???
	int textWidth = fm.stringWidth(s);
	int textWidth2 = fm.stringWidth(s2);
	int textHeight = fm.getHeight();
	center = x1 + (width - textWidth)/2;//(x1+x2)/2- s.length()*3;

	Max = 60;
	if(textWidth2>textWidth){
		textWidth = textWidth2;
	}
	if((textWidth) > (Max)){
		Max = textWidth + 20;
	}
	width = Max;
	x2 = x1 + Max;
	y2 = y1+height;
	
	g.setColor(new java.awt.Color(247,250,255));
	g.fillRect( x1, y1,  width,  height);	//white background for rect.
	g.setColor(new java.awt.Color(40,38,217));//new java.awt.Color(0,0,75));
		
	//draw rectangle
	g.drawLine( x1,  y1,  x2,  y1);   
	g.drawLine( x2,  y1,  x2,  y2);
	g.drawLine( x2,  y2,  x1,  y2);
	g.drawLine( x1,  y2,  x1,  y1);
	//draw 3D backdrop
	for(int i = 1; i<6; i++){
		g.drawLine(x1+i, y1-i, x2+i, y1-i);
		g.drawLine(x2+i, y1-i, x2+i, y2-i);
	}
/*	g.drawLine(x1+2, y1-2, x2+2, y1-2);
	g.drawLine(x1+3, y1-3, x2+3, y1-3);
	g.drawLine(x1+4, y1-4, x2+4, y1-4);
	g.drawLine(x1+5, y1-5, x2+5, y1-5);
	g.drawLine(x2+1, y1-1, x2+1, y2-1);
	g.drawLine(x2+2, y1-2, x2+2, y2-2);
	g.drawLine(x2+3, y1-3, x2+3, y2-3);*/
//	int h =  height/3;
//	g.drawLine(x1, y1 + textHeight + 3, x2, y1+textHeight+3);

	center = x1 + (width - textWidth)/2;//(x1+x2)/2- s.length()*3;

	//draw text in rectangle
	g.setColor(Color.black);
	g.drawString(s,center, y1+16);
	g.drawString(s2,center, y1+18+textHeight);
}
	//- - - - - - - - -
	// Draw a blue line
	//- - - - - - - - -
public void drawSelected(java.awt.Graphics g) {
	//draw and orange rectangle just inside the perimeter of the
	//component and one just outside the perimeter
	g.setColor(new java.awt.Color(255,170,71));
	g.drawLine(x1-1, y1-1, x2+1, y1-1);   
	g.drawLine(x2+1, y1-1, x2+1, y2+1);
	g.drawLine(x2+1, y2+1, x1-1, y2+1);
	g.drawLine(x1-1, y2+1, x1-1, y1-1);
	g.drawLine(x1+1, y1+1, x2-1, y1+1);   
	g.drawLine(x2-1, y1+1, x2-1, y2-1);
	g.drawLine(x2-1, y2-1, x1+1, y2-1);
	g.drawLine(x1+1, y2-1, x1+1, y1+1);
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 3:50:08 PM)
 * @return java.lang.String
 */
public String getFname() {
	return aName + " : " + name;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getName() {
	return name;
}
	//- - - - - - - - -
	// Draw a blue line
	//- - - - - - - - -
public void paint(java.awt.Graphics g) {
			
	//draw rectangle
	g.drawRect(x1+75,y1+75,width,height);
	if(name!=""){
		g.drawString(name,center+75, y1+13+75);
	}
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void resetMax() {
	Max=60;
	MaxH = 50;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setAName(String s) {
	aName = s;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setName(String s) {
	name = s;
}
}
