package system;

/**
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
 import java.awt.*;
public class ATconnectionGRFX extends Line {
	String text = "";
	int x3f,x4f,y3f,y4f;
	int one =1;
	int two =2;
	int both =3;
	int Arrow =2;
	final static float dash1[] = {10.0f};
	final static BasicStroke dashed = new BasicStroke(3.0f,
		BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER, 10.0f,dash1,0.0f);
	final static BasicStroke stroke = new BasicStroke(1.0f);
	final static BasicStroke stroke2 = new BasicStroke(3.0f);
/**
 * ATtransitionGRFX constructor comment.
 */
public ATconnectionGRFX() {
	super();
}
/**
 * ATtransitionGRFX constructor comment.
 */
public ATconnectionGRFX(ATconnectionGRFX cp) {
	super(cp);
}
/**
 * This method was created in VisualAge.
 */
public void Arrow() {
	
	int a = 10;
	double x = (x(n()-2)-x(n()-1));	
	double y = (y(n()-2)-y(n()-1));	
	double dist_2 = (x)*(x) + (y)*(y);
	
	//find distance between two points.
	double dist = Math.sqrt(dist_2);	

	//find point 20 pts away from final point and still on line
	double xi_dist = (a*x)/dist;
	double yi_dist = (a*y)/dist;
	
	double xi =0;
	double yi =0;
	
	xi = x(n()-1)+xi_dist;	
	yi = y(n()-1)+yi_dist;
		
	//find two final points for arrow lines.
	if (type() != "loop") {
		x1f = (int)(xi - (yi_dist/3));
		y1f = (int)(yi + (xi_dist/3));	

		x2f = (int)(xi + (yi_dist/3));
		y2f = (int)(yi - (xi_dist/3));
		w = (int)xi;
		v = (int)yi;

		x = x(1)-x(0);
		y = y(1)-y(0);
		dist_2 = x*x+y*y;
		dist = Math.sqrt(dist_2);
		xi_dist = (a*x)/dist;
		yi_dist = (a*y)/dist;

		xi = x(0)+xi_dist;
		yi = y(0)+yi_dist;

		x3f = (int)(xi - (yi_dist/3));
		y3f = (int)(yi + (xi_dist/3));	

		x4f = (int)(xi + (yi_dist/3));
		y4f = (int)(yi - (xi_dist/3));
		
	} else {
		//Loop();
	}
}
	//- - - - - - - - -
	// Draw a blue line
	//- - - - - - - - -
public void drawError(java.awt.Graphics g) {
	g.setColor(Color.yellow);
	for (int i=0; i<n()-1; i++){		//draw the actual line
		for (int n=-3; n<4; n++){
			g.drawLine(x(i)+n,y(i)+n,x(i+1)+n,y(i+1)+n);
		}
	}
}
/**
 * This method was created in VisualAge.
 * @param g Graphics
 */
public void drawLine(Graphics g) {
	Graphics2D g2 = (Graphics2D)g;
	if(second != first){
		g2.setStroke(stroke);
		g2.setColor(new java.awt.Color(201,0,0));
		for (int i=0; i<n()-1; i++){							//draw the actual line
			g2.drawLine(x(i),y(i),x(i+1),y(i+1));
		}
		g2.setColor(Color.black);
	} else {
		g2.setStroke(dashed);
		g2.setColor(new java.awt.Color(92,225,102));
		for (int i=0; i<n()-1; i++){		//draw the actual line
		//	for (int n=-1; n<2; n++){
				g2.drawLine(x(i)/*+n*/,y(i)/*+n*/,x(i+1)/*+n*/,y(i+1)/*+n*/);
		//	}
		}
		g2.setColor(Color.black);
	}
	g2.setStroke(stroke);
	if(Arrow == two || Arrow == both){
		g2.drawLine(x(n()-1),y(n()-1),x1f,y1f);	//draw the two lines going back at an angle
		g2.drawLine(x(n()-1),y(n()-1),x2f,y2f);	//to form the arrow
	}
	if(Arrow == one || Arrow == both){
		g2.drawLine(x(0),y(0),x3f,y3f);
		g2.drawLine(x(0),y(0),x4f,y4f);
	}
	g2.setColor(Color.black);								//set color to black for text
	int mid = n()/2;										//find middle of points on line
	int x = (x(mid-1) + x(mid))/2 - text.length()*3;		//find x and y for where the title
	int y = (y(mid-1) + y(mid))/2 - 3;					//will be placed
	g2.drawString(text,x,y);								//write the title
}
	//- - - - - - - - -
	// Draw a blue line
	//- - - - - - - - -
public void drawSelected(java.awt.Graphics g) {
	Graphics2D g2 = (Graphics2D)g;
	g2.setStroke(stroke2);
	g2.setColor(Color.orange);
//	g2.setStroke(stroke2);

//		if (type != "loop"){
	if(second != first){
		for (int i=0; i<n()-1; i++){		//draw the actual line
			g2.drawLine(x(i),y(i),x(i+1),y(i+1));
		}
		g2.setStroke(stroke);
		g2.setColor(Color.red);
		for (int i=0; i<n()-1; i++){
			g2.drawLine(x(i),y(i),x(i+1),y(i+1));
		}
		g2.setColor(Color.blue);
		for (int i=1; i<n()-1; i++){		//draw the actual line
			g2.drawOval(x(i)-4,y(i)-4,8,8);
		}
	} else{
//		g2.drawArc(x(0)+9,y(0)-25,28,52,0,180);	//draw the arc
//		g2.drawArc(x(0)+7,y(0)-25,32,48,0,180);	//draw the arc

		for (int i=0; i<n()-1; i++){		//draw the actual line
			g2.drawLine(x(i),y(i),x(i+1),y(i+1));
		}
		g2.setStroke(dashed);
		g2.setColor(new java.awt.Color(92,225,102));
		for (int i=0; i<n()-1; i++){		//draw the actual line
			g2.drawLine(x(i),y(i),x(i+1),y(i+1));
		}
		g2.setStroke(stroke);
		g2.setColor(Color.blue);
		for (int i=1; i<n()-1; i++){		//draw the actual line
			g2.drawOval(x(i)-4,y(i)-4,8,8);
		}
	}

}
/**
 * This method was created in VisualAge.
 */
public void getGraphics() {
}
/**
 * Insert the method's description here.
 * Creation date: (10/27/99 10:51:31 AM)
 */
public String getText() {
	return text;
}
/**
 * This method was created in VisualAge.
 * @param g Graphics
 */
public void paint(Graphics g) {
	Graphics2D g2 = (Graphics2D)g;
	if(second != first){
		g2.setStroke(stroke);
		g2.setColor(Color.red);
		for (int i=0; i<n()-1; i++){							//draw the actual line
			g2.drawLine(x(i)+75,y(i)+75,x(i+1)+75,y(i+1)+75);
		}
		g2.setColor(Color.black);
	} else {
		g2.setStroke(dashed);
		g2.setColor(Color.green);
		for (int i=0; i<n()-1; i++){		//draw the actual line
		//	for (int n=-1; n<2; n++){
				g2.drawLine(x(i)+75/*+n*/,y(i)+75/*+n*/,x(i+1)+75/*+n*/,y(i+1)+75/*+n*/);
		//	}
		}
		g2.setColor(Color.black);
	}
	g2.setStroke(stroke);
	if(Arrow == two || Arrow == both){
		g2.drawLine(x(n()-1)+75,y(n()-1)+75,x1f+75,y1f+75);	//draw the two lines going back at an angle
		g2.drawLine(x(n()-1)+75,y(n()-1)+75,x2f+75,y2f+75);	//to form the arrow
	}
	if(Arrow == one || Arrow == both){
		g2.drawLine(x(0)+75,y(0)+75,x3f+75,y3f+75);
		g2.drawLine(x(0)+75,y(0)+75,x4f+75,y4f+75);
	}
	g2.setColor(Color.black);								//set color to black for text
	int mid = n()/2;										//find middle of points on line
	int x = (x(mid-1) + x(mid))/2 - text.length()*3;		//find x and y for where the title
	int y = (y(mid-1) + y(mid))/2 - 3;					//will be placed
	if(text!= ""){
		g2.drawString(text,x+75,y+75);								//write the title
	}
}
/**
 * This method was created in VisualAge.
 * @param state system.ATstate
 */
public void place(ATstate state) {
	
}
/**
 * Insert the method's description here.
 * Creation date: (11/18/99 3:48:11 PM)
 * @param Arrow int
 */
public void setArrow(String Ord) {
	if(Ord == "first"){
		Arrow = one;
	} else if(Ord == "second"){
		Arrow = two;
	} else if(Ord == "both"){
		Arrow = both;
	}
}
/**
 * Insert the method's description here.
 * Creation date: (12/2/99 12:48:11 PM)
 */
public void setEmptyConn(Square sq) {
	if(first==second){
		second = sq;
		first = sq;
	//	setX(1,first.center_x-100);
	//	setY(1,first.center_y);
		first.add(this,0,1);
		//first.rearrangeLines(0);
		pos1 = 'x';
		num1 = 1;
	}
	//System.out.println("x1f,y1f = " + x(0) + "," + y(0));
	//System.out.println("x2f,y2f = " + x(1) + "," + y(1));
}
/**
 * This method was created in VisualAge.
 */
public void setText(String s) {
	text = s;
}
}
