package Editor;

/**
 * Insert the type's description here.
 * Used to deside the asynchronicity of a system.
 * Creation date: (6/7/00 10:38:49 AM)
 * @author: Jennifer Mifflin
  *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
import system.*;

public class AsynchWindow extends javax.swing.JDialog {
	private javax.swing.JPanel ivjJFrameContentPane = null;

	//label and text field
	private javax.swing.JLabel ivjJLabel1 = null;
	private javax.swing.JTextField ivjJTextField1 = null;
	
	//buttons
	private javax.swing.JButton ivjOKButton = null;
	private javax.swing.JButton ivjCancelButton = null;
	
	private int number = 0;
	//message area
	java.awt.TextArea sysMsgArea = null;
	ATsystem sys;

class IvjEventHandler implements java.awt.event.ActionListener {
		public void actionPerformed(java.awt.event.ActionEvent e) {
			if (e.getSource() == AsynchWindow.this.getOKButton()) 
				connEtoC1();
			if (e.getSource() == AsynchWindow.this.getCancelButton()) 
				connEtoC2();
		};
	};
	IvjEventHandler ivjEventHandler = new IvjEventHandler();
/**
 * AsynchWindow constructor comment.
 */
public AsynchWindow(ATsystem s) {
	super();
	this.sys = s;
	initialize();
}
/**
 * Comment
 */
public void cancelButton_ActionEvents() {
	this.dispose();
	return;
}
/**
 * connEtoC1:  (OKButton.action. --> AsynchWindow.oKButton_ActionEvents()V)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC1() {
	try {
		// user code begin {1}
		// user code end
		this.oKButton_ActionEvents();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoC2:  (CancelButton.action. --> AsynchWindow.cancelButton_ActionEvents()V)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC2() {
	try {
		// user code begin {1}
		// user code end
		this.cancelButton_ActionEvents();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * Return the CancelButton property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getCancelButton() {
	if (ivjCancelButton == null) {
		try {
			ivjCancelButton = new javax.swing.JButton();
			ivjCancelButton.setName("CancelButton");
			ivjCancelButton.setFont(new java.awt.Font("serif.bold", 1, 12));
			ivjCancelButton.setText("Cancel");
			ivjCancelButton.setBounds(18, 60, 71, 27);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjCancelButton;
}
/**
 * Return the JFrameContentPane property value.
 * @return javax.swing.JPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JPanel getJFrameContentPane() {
	if (ivjJFrameContentPane == null) {
		try {
			ivjJFrameContentPane = new javax.swing.JPanel();
			ivjJFrameContentPane.setName("JFrameContentPane");
			ivjJFrameContentPane.setLayout(null);
			getJFrameContentPane().add(getJLabel1(), getJLabel1().getName());
			getJFrameContentPane().add(getJTextField1(), getJTextField1().getName());
			getJFrameContentPane().add(getCancelButton(), getCancelButton().getName());
			getJFrameContentPane().add(getOKButton(), getOKButton().getName());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJFrameContentPane;
}
/**
 * Return the JLabel1 property value.
 * @return javax.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JLabel getJLabel1() {
	if (ivjJLabel1 == null) {
		try {
			ivjJLabel1 = new javax.swing.JLabel();
			ivjJLabel1.setName("JLabel1");
			ivjJLabel1.setText("Buffer Size:");
			ivjJLabel1.setBounds(23, 28, 72, 17);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJLabel1;
}
/**
 * Return the JTextField1 property value.
 * @return javax.swing.JTextField
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JTextField getJTextField1() {
	if (ivjJTextField1 == null) {
		try {
			ivjJTextField1 = new javax.swing.JTextField();
			ivjJTextField1.setName("JTextField1");
			ivjJTextField1.setBounds(99, 24, 38, 21);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJTextField1;
}
/**
 * Return the OKButton property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getOKButton() {
	if (ivjOKButton == null) {
		try {
			ivjOKButton = new javax.swing.JButton();
			ivjOKButton.setName("OKButton");
			ivjOKButton.setFont(new java.awt.Font("serif.bold", 1, 12));
			ivjOKButton.setText("OK");
			ivjOKButton.setBounds(108, 60, 64, 27);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjOKButton;
}
/**
 * Called whenever the part throws an exception.
 * @param exception java.lang.Throwable
 */
private void handleException(java.lang.Throwable exception) {

	/* Uncomment the following lines to print uncaught exceptions to stdout */
	// System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	// exception.printStackTrace(System.out);
}
/**
 * Initializes connections
 * @exception java.lang.Exception The exception description.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initConnections() throws java.lang.Exception {
	// user code begin {1}
	// user code end
	getOKButton().addActionListener(ivjEventHandler);
	getCancelButton().addActionListener(ivjEventHandler);
}
/**
 * Initialize the class.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initialize() {
	try {
		// user code begin {1}
		// user code end
		setName("AsynchWindow");
		setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		setSize(199, 132);
		setContentPane(getJFrameContentPane());
		initConnections();
	} catch (java.lang.Throwable ivjExc) {
		handleException(ivjExc);
	}
	// user code begin {2}
	// user code end
}
/**
 * Comment
 */
public void oKButton_ActionEvents() {
	//get the number that placed in the text field
	int j = Integer.parseInt(getJTextField1().getText());
	//verify the conversations sending that number
	verifyConversationsSynch(j);
	//close this window
	this.dispose();
	return;
}
//method for handling mouseUp action
/**
 * This method was created in VisualAge.
 * @param ta java.awt.TextArea
 */
public void setSysMsgArea(java.awt.TextArea ta) {
	//sets the system Message area
	sysMsgArea = ta;
}
public void sysMsg(String s) {
	//writes s in the system message area
	if (sysMsgArea != null)
		sysMsgArea.append(s + "\n");
}
/**
 * This method was created in VisualAge.
 */
public void verifyConversationsSynch(int j)
{
	sysMsg("Verifying...");
	java.util.Vector ErrorVector = Verify.VCRun.verify(sys.getVerifyVector(),j);

	// the rest sets up the graphical error display
	java.util.Enumeration Enum = ErrorVector.elements();
	system.ATerror e = null;
	system.ATconversation c;
	system.ATstatetable t = null;
	java.util.Enumeration Convs = sys.returnConvs();
	java.util.Enumeration states;
	java.util.Enumeration transitions;
	system.ATtableElement s;
	system.ATtransition trans;	
	while(Convs.hasMoreElements()){
		c = (system.ATconversation) Convs.nextElement();
		t = c.getStateTable(system.ATsystem.INITIATOR);
		states = t.returnStates();
		while(states.hasMoreElements()){
			s = (system.ATtableElement) states.nextElement();
			s.errorSelected = false;
		}
		transitions = t.returnTrans();
		while(transitions.hasMoreElements()){
			trans = (ATtransition) transitions.nextElement();
			trans.errorSelected = false;
		}
		t = c.getStateTable(system.ATsystem.RESPONDER);
		states = t.returnStates();
		while(states.hasMoreElements()){
			s = (system.ATtableElement) states.nextElement();
			s.errorSelected = false;
		}
		transitions = t.returnTrans();
		while(transitions.hasMoreElements()){
			trans = (ATtransition) transitions.nextElement();
			trans.errorSelected = false;
		}
	}
	
	while (Enum.hasMoreElements())
	{
		Convs = sys.returnConvs();
		e = (system.ATerror) Enum.nextElement();
		if (e.getType() == system.ATerror.DEADLOCK)
		{
			while (Convs.hasMoreElements())
			{
				c = (system.ATconversation) Convs.nextElement();
				if (c.getName().equals(e.getConvName()))
				{
					if (e.getParticipantName().equals("Initiator"))
					{
						t = c.getStateTable(system.ATsystem.INITIATOR);
					}
					else
					{
						t = c.getStateTable(system.ATsystem.RESPONDER);
					}
					transitions = t.returnTrans();
					while (transitions.hasMoreElements())
					{
						trans = (system.ATtransition) transitions.nextElement();
						
						if (trans.getRecMessage().equals(e.getStateTransition()) &&
							trans.getCurrentState().getName().equals(e.getCurrentState()))
						{
							trans.errorSelected = true;
						}
					}
				}
			}
			
		}
		if (e.getType() == system.ATerror.PROGRESS)
		{
			while (Convs.hasMoreElements())
			{
				c = (system.ATconversation) Convs.nextElement();
				if (c.getName().equals(e.getConvName()))
				{
					if (e.getParticipantName().equals("Initiator"))
					{
						t = c.getStateTable(system.ATsystem.INITIATOR);
					}
					else
					{
						t = c.getStateTable(system.ATsystem.RESPONDER);
					}
					states = t.returnStates();
					while (states.hasMoreElements())
					{
						s = (system.ATtableElement) states.nextElement();
						if (s.getName().equals(e.getCurrentState()))
						{
							s.errorSelected = true;
						}
					}
				}
			}
		}
	}
	repaint();
	sysMsg("  Errors highlighted");
	sysMsg("Complete");
}
}
