package Editor;

import javax.swing.*;
import java.util.Vector;
/**
 * This type was created in VisualAge.
  *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
public class ComponentMethodEditDialog extends javax.swing.JDialog implements java.awt.event.ActionListener,java.awt.event.ItemListener
{
	
	private JButton ivjcancelButton = null;
	private JButton ivjchangeButton=null;
	private JButton ivjdeleteButton=null;
	
	private JPanel ivjJDialogContentPane = null;
	
	private JDialog ivjmethodDialog = null;
	
	private JLabel ivjnameLabel = null;
	private JLabel ivjparamsLabel = null;
	private JLabel ivjpostLabel = null;
	private JLabel ivjpreLabel = null;
	private JLabel ivjreturnLabel = null;
	
	private JTextField ivjnameTextArea = null;
	private JTextField ivjreturnTextArea = null;
	private JTextArea ivjparamsTextArea = null;
	private JTextArea ivjpostTextArea = null;
	private JTextArea ivjpreTextArea = null;
	
	private JCheckBox ivjvisibleCheckBox = null;
	
	private system.ATagentComponent aComp = null;
	//private system.ATagentComponentMethod aCompMethod;
	
	private String name;
	private String returnType;
	private String pre;
	private String post;
	private String params;
	
	private boolean visible=false;
	
	private Vector allMethods=new Vector();
	
	private int location=0;
	
	private system.ATagentComponentMethod selectedMeth;
	
	private javax.swing.JScrollPane ivjJScrollPane1 = null;
	private javax.swing.JScrollPane ivjJScrollPane2 = null;
	private javax.swing.JScrollPane ivjJScrollPane3 = null;
	
/**
 * Constructor
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
public ComponentMethodEditDialog(Vector methods, int methLoc)
{
	super((java.awt.Frame)null,true);
	allMethods=methods;
	location=methLoc;
	
	selectedMeth = (system.ATagentComponentMethod) allMethods.elementAt(methLoc);
	name=selectedMeth.getName();
	returnType=selectedMeth.getReturnType();
	pre=selectedMeth.getPre();
	post=selectedMeth.getPost();
	params=selectedMeth.getParams();
	visible=selectedMeth.getVisible();
	
	
	initialize();
}
/**
 * Method to handle events for the ActionListener interface.
 * @param e java.awt.event.ActionEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
public void actionPerformed(java.awt.event.ActionEvent e)
{
	if ((e.getSource() == getchangeButton()))
	{
		changePushed();
	}
	else
		if ((e.getSource() == getcancelButton()))
		{
			cancelPushed();
		}
		else
			if ((e.getSource() == getdeleteButton()))
			{
				deletePushed();
			}
}
private void cancelPushed()
{
	this.dispose();
}
private void changePushed() {
	
	name  = getnameTextArea().getText();
	returnType = getreturnTextArea().getText();
	pre=getpreTextArea().getText();
	post=getpostTextArea().getText();
	params=getparamsTextArea().getText();
		
	selectedMeth.setName(name);
	selectedMeth.setReturnType(returnType);
	selectedMeth.setPre(pre);
	selectedMeth.setPost(post);
	selectedMeth.setParams(params);
	selectedMeth.setVisible(visible);
	selectedMeth.setMethodView();

	allMethods.setElementAt(selectedMeth, location);
	aComp.setMethods(allMethods);
	

	this.dispose();
}
private void deletePushed()
{
	allMethods.removeElementAt(location);
	aComp.setMethods(allMethods);
	this.dispose();
}
/**
 * Return the cancelButton property value.
 * @return com.sun.java.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JButton getcancelButton() {
	if (ivjcancelButton == null) {
		try {
			ivjcancelButton = new JButton();
			ivjcancelButton.setName("cancelButton");
			ivjcancelButton.setText("Cancel");
			ivjcancelButton.setBounds(263, 330, 85, 25);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjcancelButton;
}
/**
 * Return the addButton property value.
 * @return com.sun.java.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JButton getchangeButton()
{
	if (ivjchangeButton == null)
	{
		try
		{
			ivjchangeButton = new JButton();
			ivjchangeButton.setName("changeButton");
			ivjchangeButton.setText("Change");
			ivjchangeButton.setBounds(173, 330, 85, 25);
			// user code begin {1}
			// user code end
		}
		catch (java.lang.Throwable ivjExc)
		{
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjchangeButton;
}
/**
 * Return the cancelButton property value.
 * @return com.sun.java.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JButton getdeleteButton()
{
	if (ivjdeleteButton == null)
	{
		try
		{
			ivjdeleteButton = new JButton();
			ivjdeleteButton.setName("deleteButton");
			ivjdeleteButton.setText("Delete");
			ivjdeleteButton.setBounds(83, 330, 85, 25);
			// user code begin {1}
			// user code end
		}
		catch (java.lang.Throwable ivjExc)
		{
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjdeleteButton;
}
/**
 * Return the JDialogContentPane property value.
 * @return com.sun.java.swing.JPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JPanel getJDialogContentPane() {
	if (ivjJDialogContentPane == null) {
		try {
			ivjJDialogContentPane = new JPanel();
			ivjJDialogContentPane.setName("JDialogContentPane");
			ivjJDialogContentPane.setLayout(null);
			getJDialogContentPane().add(getnameLabel(), getnameLabel().getName());
			getJDialogContentPane().add(getnameTextArea(), getnameTextArea().getName());
			getJDialogContentPane().add(getreturnLabel(), getreturnLabel().getName());
			getJDialogContentPane().add(getreturnTextArea(), getreturnTextArea().getName());
			getJDialogContentPane().add(getpreLabel(), getpreLabel().getName());
			getJDialogContentPane().add(getJScrollPane2(), getpreTextArea().getName());
			getJDialogContentPane().add(getpostLabel(), getpostLabel().getName());
			getJDialogContentPane().add(getJScrollPane3(), getpostTextArea().getName());
			getJDialogContentPane().add(getparamsLabel(), getparamsLabel().getName());
			getJDialogContentPane().add(getJScrollPane1(), getparamsTextArea().getName());
			getJDialogContentPane().add(getchangeButton(), getchangeButton().getName());
			getJDialogContentPane().add(getcancelButton(), getcancelButton().getName());
			getJDialogContentPane().add(getdeleteButton(), getdeleteButton().getName());
			getJDialogContentPane().add(getvisibleCheckBox(), getvisibleCheckBox().getName());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjJDialogContentPane;
}
/**
 * Return the JScrollPane1 property value.
 * @return javax.swing.JScrollPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JScrollPane getJScrollPane1() {
	if (ivjJScrollPane1 == null) {
		try {
			ivjJScrollPane1 = new javax.swing.JScrollPane();
			ivjJScrollPane1.setName("JScrollPane1");
			ivjJScrollPane1.setBounds(113, 71, 223, 75);
			getJScrollPane1().setViewportView(getparamsTextArea());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJScrollPane1;
}
/**
 * Return the JScrollPane2 property value.
 * @return javax.swing.JScrollPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JScrollPane getJScrollPane2() {
	if (ivjJScrollPane2 == null) {
		try {
			ivjJScrollPane2 = new javax.swing.JScrollPane();
			ivjJScrollPane2.setName("JScrollPane2");
			ivjJScrollPane2.setBounds(113,156, 223, 75);
			getJScrollPane2().setViewportView(getpreTextArea());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJScrollPane2;
}
/**
 * Return the JScrollPane3 property value.
 * @return javax.swing.JScrollPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JScrollPane getJScrollPane3() {
	if (ivjJScrollPane3 == null) {
		try {
			ivjJScrollPane3 = new javax.swing.JScrollPane();
			ivjJScrollPane3.setName("JScrollPane3");
			ivjJScrollPane3.setBounds(113, 241, 223, 75);
			getJScrollPane3().setViewportView(getpostTextArea());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJScrollPane3;
}
/**
 * Return the methodDialog property value.
 * @return com.sun.java.swing.JDialog
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JDialog getmethodDialog() {
	if (ivjmethodDialog == null) {
		try {
			ivjmethodDialog = new JDialog();
			ivjmethodDialog.setName("methodDialog");
			ivjmethodDialog.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
			ivjmethodDialog.setBounds(19, 16, 388, 290);
			ivjmethodDialog.setTitle("Component Method");
			getmethodDialog().setContentPane(getJDialogContentPane());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjmethodDialog;
}
/**
 * Return the nameLabel property value.
 * @return com.sun.java.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JLabel getnameLabel() {
	if (ivjnameLabel == null) {
		try {
			ivjnameLabel = new JLabel();
			ivjnameLabel.setName("nameLabel");
			ivjnameLabel.setText("Method Name");
			ivjnameLabel.setBounds(31, 11, 80, 15);

		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjnameLabel;
}
/**
 * Return the nameTextArea property value.
 * @return com.sun.java.swing.JTextField
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JTextField getnameTextArea() {
	if (ivjnameTextArea == null) {
		try {
			ivjnameTextArea = new JTextField();
			ivjnameTextArea.setName("nameTextArea");
			ivjnameTextArea.setBounds(113, 11, 129, 19);
			ivjnameTextArea.setText(name);
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjnameTextArea;
}
/**
 * Return the paramsLabel property value.
 * @return com.sun.java.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JLabel getparamsLabel() {
	if (ivjparamsLabel == null) {
		try {
			ivjparamsLabel = new JLabel();
			ivjparamsLabel.setName("paramsLabel");
			ivjparamsLabel.setText("Parameters");
			ivjparamsLabel.setBounds(31, 71, 77, 15);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjparamsLabel;
}
/**
 * Return the paramsTextArea property value.
 * @return com.sun.java.swing.JTextArea
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JTextArea getparamsTextArea() {
	if (ivjparamsTextArea == null) {
		try {
			ivjparamsTextArea = new JTextArea();
			ivjparamsTextArea.setName("paramsTextArea");
			ivjparamsTextArea.setBounds(113, 71, 129, 19);
			ivjparamsTextArea.setText(params);
		
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjparamsTextArea;
}
/**
 * Return the postLabel property value.
 * @return com.sun.java.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JLabel getpostLabel() {
	if (ivjpostLabel == null) {
		try {
			ivjpostLabel = new JLabel();
			ivjpostLabel.setName("postLabel");
			ivjpostLabel.setText("Postcondtion");
			ivjpostLabel.setBounds(31, 241, 77, 15);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjpostLabel;
}
/**
 * Return the postTextArea property value.
 * @return com.sun.java.swing.JTextArea
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JTextArea getpostTextArea() {
	if (ivjpostTextArea == null) {
		try {
			ivjpostTextArea = new JTextArea();
			ivjpostTextArea.setName("postTextArea");
			ivjpostTextArea.setBounds(113, 168, 223, 56);
			ivjpostTextArea.setText(post);
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjpostTextArea;
}
/**
 * Return the preLabel property value.
 * @return com.sun.java.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JLabel getpreLabel() {
	if (ivjpreLabel == null) {
		try {
			ivjpreLabel = new JLabel();
			ivjpreLabel.setName("preLabel");
			ivjpreLabel.setText("Precondition");
			ivjpreLabel.setBounds(31, 156, 79, 15);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjpreLabel;
}
/**
 * Return the preTextArea property value.
 * @return com.sun.java.swing.JTextArea
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JTextArea getpreTextArea() {
	if (ivjpreTextArea == null) {
		try {
			ivjpreTextArea = new JTextArea();
			ivjpreTextArea.setName("preTextArea");
			ivjpreTextArea.setBounds(113, 101, 223, 56);
			ivjpreTextArea.setText(pre);
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjpreTextArea;
}
/**
 * Return the returnLabel property value.
 * @return com.sun.java.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JLabel getreturnLabel() {
	if (ivjreturnLabel == null) {
		try {
			ivjreturnLabel = new JLabel();
			ivjreturnLabel.setName("returnLabel");
			ivjreturnLabel.setText("Return Type");
			ivjreturnLabel.setBounds(31, 41, 80, 15);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjreturnLabel;
}
/**
 * Return the returnTextArea property value.
 * @return com.sun.java.swing.JTextField
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JTextField getreturnTextArea() {
	if (ivjreturnTextArea == null) {
		try {
			ivjreturnTextArea = new JTextField();
			ivjreturnTextArea.setName("returnTextArea");
			ivjreturnTextArea.setBounds(113, 41, 129, 19);
			ivjreturnTextArea.setText(returnType);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjreturnTextArea;
}
/**
 * Return the visibleCheckBox property value.
 * @return com.sun.java.swing.JCheckBox
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JCheckBox getvisibleCheckBox() {
	if (ivjvisibleCheckBox == null) {
		try {
			ivjvisibleCheckBox = new JCheckBox("Visible",visible);
			ivjvisibleCheckBox.setName("visibleCheckBox");
			//ivjvisibleCheckBox.setText("Visible");
			ivjvisibleCheckBox.setBounds(289, 11, 69, 25);
			ivjvisibleCheckBox.addItemListener(this);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjvisibleCheckBox;
}
/**
 * Called whenever the part throws an exception.
 * @param exception java.lang.Throwable
 */
private void handleException(Throwable exception) {

	/* Uncomment the following lines to print uncaught exceptions to stdout */
	// System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	// exception.printStackTrace(System.out);
}
/**
 * Initializes connections
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initConnections()
{
	getchangeButton().addActionListener(this);
	getcancelButton().addActionListener(this);
	getdeleteButton().addActionListener(this);
}
/**
 * Initialize the class.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initialize() {
	setName("ComponentMethodDialog");
	setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
	setSize(390, 400);
	setTitle("Component Method");
	setContentPane(getJDialogContentPane());
	initConnections();
}
/**
 * This method was created in VisualAge.
 */
public void itemStateChanged(java.awt.event.ItemEvent evt)
{
	//check checkbox status
	if (evt.getItem() == getvisibleCheckBox())
		visible = true;

	//reset values if checkboxes deselected
	if (evt.getStateChange() == java.awt.event.ItemEvent.DESELECTED)
	{
		if (evt.getItem() == getvisibleCheckBox())
			visible = false;
	}
}
/**
 * This method was created in VisualAge.
 * @param t system.ATtransition
 */
public void setComp(system.ATagentComponent c)
{
	aComp = c;
}
}
