package Editor;

/**
 * Insert the type's description here.
 * Creation date: (04-Feb-00 8:10:19 AM)
 * @author: 
  *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
public class ComponentPropertiesDialog extends javax.swing.JDialog implements java.awt.event.ActionListener, java.awt.event.ItemListener {
	
	private javax.swing.JLabel ivjConstraintLabel = null;
	private javax.swing.JLabel ivjNameLabel = null;
	
	private javax.swing.JDialog ivjJDialog1 = null;
	
	private javax.swing.JPanel ivjJDialogContentPane = null;
	
	private javax.swing.JTextArea ivjJTextField2 = null;
	private javax.swing.JTextField ivjNameTextField = null;
	
	private javax.swing.JCheckBox ivjSubstructureBox = null;
	
	private javax.swing.JButton ivjApplyButton = null;
	
	private String name = "";
	
	private system.ATagentComponent lComp = null;
	system.ATagent ag = null;
	
	private boolean substructure=false;
/**
 * NewComponentPropertiesDialog constructor comment.
 */
public ComponentPropertiesDialog(system.ATagent a, system.ATagentComponent c) {
	super((java.awt.Frame)null,true);
	ag = a;
	if(c.gethasSub()){
		substructure = true;
	}
	setComp(c);
	initialize();

/* Second constructor.  I removed it because I needed to know if it was used
	anywhere.  It was not so I never put it back in.  -JAG
		
	public ComponentPropertiesDialog(String s1,boolean sub) {
		super();
		name = s1;
		substructure=sub;
		initialize();
	}
*/

}
/**
 * Method to handle events for the ActionListener interface.
 * @param e java.awt.event.ActionEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
public void actionPerformed(java.awt.event.ActionEvent e)
{
	// user code begin {1}
	// user code end
	if ((e.getSource() == getApplyButton()))
	{
		connEtoC1();
	}
	// user code begin {2}
	// user code end
}
private void applyPushed()
{
	String cname = getNameTextField().getText();

	String cnameL = cname;
	int i=2;
	while(!name.equals(cnameL) && ag.repeatName(cnameL)) {
		cnameL = cname + "(" + Integer.toString(i++) + ")";
	}

	//set attribute values
	lComp.setName(cnameL);
	this.dispose();
}
/**
 * connEtoC1:  (ApplyButton.action. --> PropertiesDialog.applyPushed()V)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC1() {
	try {
		// user code begin {1}
		// user code end
		this.applyPushed();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * Return the ApplyButton property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getApplyButton() {
	if (ivjApplyButton == null) {
		try {
			ivjApplyButton = new javax.swing.JButton();
			ivjApplyButton.setName("ApplyButton");
			ivjApplyButton.setText("Apply");
			ivjApplyButton.setBounds(141, 195, 85, 27);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjApplyButton;
}
/**
 * Return the ConstraintLabel property value.
 * @return javax.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JLabel getConstraintLabel() {
	if (ivjConstraintLabel == null) {
		try {
			ivjConstraintLabel = new javax.swing.JLabel();
			ivjConstraintLabel.setName("ConstraintLabel");
			ivjConstraintLabel.setText("Component Constraints");
			ivjConstraintLabel.setBounds(14, 57, 139, 17);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjConstraintLabel;
}
/**
 * Return the JDialog1 property value.
 * @return javax.swing.JDialog
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JDialog getJDialog1() {
	if (ivjJDialog1 == null) {
		try {
			ivjJDialog1 = new javax.swing.JDialog();
			ivjJDialog1.setName("JDialog1");
			ivjJDialog1.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
			ivjJDialog1.setBounds(75, 106, 372, 232);
			ivjJDialog1.setTitle("Component Properties");
			getJDialog1().setContentPane(getJDialogContentPane());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJDialog1;
}
/**
 * Return the JDialogContentPane property value.
 * @return javax.swing.JPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JPanel getJDialogContentPane() {
	if (ivjJDialogContentPane == null) {
		try {
			ivjJDialogContentPane = new javax.swing.JPanel();
			ivjJDialogContentPane.setName("JDialogContentPane");
			ivjJDialogContentPane.setLayout(null);
			getJDialogContentPane().add(getNameLabel(), getNameLabel().getName());
			getJDialogContentPane().add(getNameTextField(), getNameTextField().getName());
			getJDialogContentPane().add(getConstraintLabel(), getConstraintLabel().getName());
			getJDialogContentPane().add(getJTextField2(), getJTextField2().getName());
			getJDialogContentPane().add(getSubstructureBox(), getSubstructureBox().getName());
			getJDialogContentPane().add(getApplyButton(), getApplyButton().getName());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJDialogContentPane;
}
/**
 * Return the JTextField2 property value.
 * @return javax.swing.JTextField
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JTextArea getJTextField2() {
	if (ivjJTextField2 == null) {
		try {
			ivjJTextField2 = new javax.swing.JTextArea();
			ivjJTextField2.setName("JTextField2");
			ivjJTextField2.setBounds(157, 57, 191, 85);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJTextField2;
}
/**
 * Return the NameLabel property value.
 * @return javax.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JLabel getNameLabel() {
	if (ivjNameLabel == null) {
		try {
			ivjNameLabel = new javax.swing.JLabel();
			ivjNameLabel.setName("NameLabel");
			ivjNameLabel.setText("Component Name");
			ivjNameLabel.setBounds(45, 20, 108, 17);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjNameLabel;
}
/**
 * Return the NameTextField property value.
 * @return javax.swing.JTextField
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JTextField getNameTextField() {
	if (ivjNameTextField == null) {
		try {
			ivjNameTextField = new javax.swing.JTextField();
			ivjNameTextField.setName("NameTextField");
			ivjNameTextField.setBounds(157, 20, 191, 21);
			ivjNameTextField.setText(name);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjNameTextField;
}
/**
 * Return the SubstructureBox property value.
 * @return javax.swing.JCheckBox
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JCheckBox getSubstructureBox() {
	if (ivjSubstructureBox == null) {
		try {
			ivjSubstructureBox = new javax.swing.JCheckBox("SubstructureBox",substructure);
			ivjSubstructureBox.setText("Contains Substructure");
			ivjSubstructureBox.setBounds(119, 151, 162, 25);
			ivjSubstructureBox.addItemListener(this);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjSubstructureBox;
}
/**
 * Called whenever the part throws an exception.
 * @param exception java.lang.Throwable
 */
private void handleException(java.lang.Throwable exception) {

	/* Uncomment the following lines to print uncaught exceptions to stdout */
	// System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	// exception.printStackTrace(System.out);
}
/**
 * Initializes connections
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initConnections()
{
	// user code begin {1}
	// user code end
	getApplyButton().addActionListener(this);
}
/**
 * Initialize the class.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initialize() {
	// user code begin {1}
	// user code end
	setName("componentPropertiesDialog");
	setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
	setSize(380, 275);
	setTitle("Component Properties");
	setContentPane(getJDialogContentPane());
	initConnections();
	// user code begin {2}
	// user code end
}
/**
 * This method was created in VisualAge.
 */
public void itemStateChanged(java.awt.event.ItemEvent evt)
{

	//check checkbox status
	if (evt.getItem() == getSubstructureBox())
	{
		substructure = true;
		lComp.setHasSub(substructure);
	}

	//reset values if checkboxes deselected
	if (evt.getStateChange() == java.awt.event.ItemEvent.DESELECTED)
	{
		if (evt.getItem() == getSubstructureBox())
			substructure = false;
		lComp.setHasSub(substructure);
	}
}
/**
 * This method was created in VisualAge.
 * @param t system.ATtransition
 */
public void setComp(system.ATagentComponent c)
{
	lComp = c;
	name = lComp.getName();
	getNameTextField().setText(name);
//	if(lComp.gethasSub()){
//		substructure = true;
//	}
//	ivjSubstructureBox = null;
//	getSubstructureBox();
//	getJDialogContentPane();
}
}
