package Editor;

/**
 * Insert the type's description here.
 * Creation date: (2/23/01 2:00:57 PM)
 * @author: 
 */
 import javax.swing.*;
public class TextWindow extends JDialog {
	
	JTextArea display;
	JScrollPane scroll;

/**
 * TextWindow constructor comment.
 */
public TextWindow() {
	this(null,400,300);
}
/**
 * TextWindow constructor comment.
 */
public TextWindow(java.awt.Frame c, int w, int h) {
	super(c);
	
	setName("text window");
	setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
	setSize(w,h);
	setLocationRelativeTo(c);

	display = new JTextArea();
	display.setLineWrap(true);
	display.setEditable(false);
	scroll = new JScrollPane(display);
	scroll.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);

	getContentPane().add(scroll,"Center");

	show();
	update(this.getGraphics());
	
}
	public void append(String text) {
		display.append(text);
		update(this.getGraphics());
	}
/**
 * Called whenever the part throws an exception.
 * @param exception java.lang.Throwable
 */
private void handleException(Throwable exception) {

	/* Uncomment the following lines to print uncaught exceptions to stdout */
	// System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	// exception.printStackTrace(System.out);
}
}
