package agentBase;

import system.*;
import java.util.*;
import javax.swing.*;
/**
 * Insert the type's description here.
 * Creation date: (10/8/99 1:41:07 PM)
 * @author: 
 */
public class LoadGUI extends JFrame {
	private JPanel ivjJFrameContentPane = null;
	private JTabbedPane ivjJTabbedPane1 = null;
	private JLabel ivjDescriptionLabel = null;
	private JButton ivjGetObject = null;
	private JPanel ivjPage1 = null;
	private JPanel ivjPage2 = null;
	private JButton ivjSelectObject = null;
	private JList ivjATobjectList = null;
	private JMenuBar ivjLoadGUIJMenuBar = null;
	private JMenu ivjObjectType = null;
	
	private JRadioButton ivjRadioAgents = null;
	private JRadioButton ivjRadioArchitectures = null;
	private JRadioButton ivjRadioConversations = null;
	private JRadioButton ivjRadioFrameworks = null;
	private JRadioButton ivjRadioProperties = null;
	private JRadioButton ivjRadioRoles = null;
	private JRadioButton ivjRadioSystems = null;
	private JRadioButton ivjRadioComponents = null;
	private JSeparator ivjJSeparator1 = null;
	private JTextPane ivjDescriptionField = null;
	private JMenu ivjOther = null;
	private String  MAML="";
	private String  type="";
	private ConnectionAgent parent = null;
	private ButtonGroup RadioGroup = null;
	IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private DefaultListModel ivjObjectGroup = null;
	private String RadioSelection=null;

	private ATobject hold=null;
	
class IvjEventHandler implements java.awt.event.ActionListener {

		public void actionPerformed(java.awt.event.ActionEvent e) {
			if (e.getSource() == LoadGUI.this.getRadioRoles()){ 
				getKeyList("system.ATrole");
				RadioSelection ="system.ATrole";
			}
			if (e.getSource() == LoadGUI.this.getRadioConversations()){ 
				getKeyList("system.ATconversation");
				RadioSelection ="system.ATconversation";
			}
			if (e.getSource() == LoadGUI.this.getRadioSystems()){ 
				getKeyList("system.ATsystem");
				RadioSelection ="system.ATsystem";
			}
			if (e.getSource() == LoadGUI.this.getRadioAgents()){ 
				getKeyList("system.ATagent");
				RadioSelection ="system.ATagent";
			}
			if (e.getSource() == LoadGUI.this.getRadioFrameworks()){ 
				getKeyList("system.ATframework");
				RadioSelection ="system.ATframework";
			}
			if (e.getSource() == LoadGUI.this.getRadioComponents()){ 
				getKeyList("system.ATagentComponent");
				RadioSelection ="system.ATagentComponent";
			}
			if (e.getSource() == LoadGUI.this.getRadioArchitectures()){ 
				getKeyList("system.ATarchitecture");
				RadioSelection ="system.ATarchitecture";
			}
			
			if (e.getSource() == LoadGUI.this.getGetObject()) {
				System.out.println("GETOBJECT pressed, radio is" + RadioSelection);
				getObject();
			}
			if (e.getSource() == LoadGUI.this.getSelectObject()) {
				System.out.println("USE pressed");
				returnObject();
			}
		};
	};

/**
 * LoadGUI constructor comment.
 */
public LoadGUI() {
	super();
	initialize();
}
/**
 * LoadGUI constructor comment.
 */
public LoadGUI(ConnectionAgent a,ATobject o) {
	super();
	initialize();
	parent=a;
	hold = o;
	type = hold.getClass().getName();
	System.out.println("Request for a "+type+" received.");
	if (type=="ATconversation") {
	 getRadioConversations().setSelected(true); 
	}

	this.setVisible(true);
}
/**
 * LoadGUI constructor comment.
 * @param title java.lang.String
 */
public LoadGUI(String title) {
	super(title);
}
/**
 * Return the ATobjectList property value.
 * @return javax.swing.JList
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JList getATobjectList() {
	if (ivjATobjectList == null) {
		try {
			ivjATobjectList = new JList();
			ivjATobjectList.setName("ATobjectList");
			ivjATobjectList.setModel(new DefaultListModel());
			ivjATobjectList.setBounds(4, 5, 130, 220);
			ivjATobjectList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjATobjectList;
}
/**
 * Return the escriptionField property value.
 * @return javax.swing.JTextPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JTextPane getDescriptionField() {
	if (ivjDescriptionField == null) {
		try {
			ivjDescriptionField = new JTextPane();
			ivjDescriptionField.setName("DescriptionField");
			ivjDescriptionField.setBackground(java.awt.Color.lightGray);
			ivjDescriptionField.setBounds(145, 24, 317, 136);
			ivjDescriptionField.setEditable(false);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjDescriptionField;
}
/**
 * Return the DescriptionLabel property value.
 * @return javax.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JLabel getDescriptionLabel() {
	if (ivjDescriptionLabel == null) {
		try {
			ivjDescriptionLabel = new JLabel();
			ivjDescriptionLabel.setName("DescriptionLabel");
			ivjDescriptionLabel.setText("Object Description:");
			ivjDescriptionLabel.setBounds(141, 6, 116, 17);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjDescriptionLabel;
}
/**
 * Return the GetObject property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JButton getGetObject() {
	if (ivjGetObject == null) {
		try {
			ivjGetObject = new JButton();
			ivjGetObject.setName("GetObject");
			ivjGetObject.setText("get Object");
			ivjGetObject.setBounds(14, 226, 107, 27);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjGetObject;
}
/**
 * Return the JFrameContentPane property value.
 * @return javax.swing.JPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JPanel getJFrameContentPane() {
	if (ivjJFrameContentPane == null) {
		try {
			ivjJFrameContentPane = new JPanel();
			ivjJFrameContentPane.setName("JFrameContentPane");
			ivjJFrameContentPane.setLayout(null);
			getJFrameContentPane().add(getJTabbedPane1(), getJTabbedPane1().getName());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJFrameContentPane;
}
/**
 * Return the JSeparator1 property value.
 * @return javax.swing.JSeparator
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JSeparator getJSeparator1() {
	if (ivjJSeparator1 == null) {
		try {
			ivjJSeparator1 = new JSeparator();
			ivjJSeparator1.setName("JSeparator1");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJSeparator1;
}
/**
 * Return the JTabbedPane1 property value.
 * @return javax.swing.JTabbedPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JTabbedPane getJTabbedPane1() {
	if (ivjJTabbedPane1 == null) {
		try {
			ivjJTabbedPane1 = new JTabbedPane();
			ivjJTabbedPane1.setName("JTabbedPane1");
			ivjJTabbedPane1.setBounds(6, 6, 472, 290);
			ivjJTabbedPane1.insertTab("Page1", null, getPage1(), null, 0);
			ivjJTabbedPane1.insertTab("Page2", null, getPage2(), null, 1);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJTabbedPane1;
}
/**
 * Insert the method's description here.
 * Creation date: (10/11/99 9:27:35 PM)
 */
public void getKeyList(String type) {
		Thread t = new Thread(new CAList(parent, parent.serverHost, parent.serverPort, type, this));
  		t.start();
}
/**
 * Return the LoadGUIJMenuBar property value.
 * @return javax.swing.JMenuBar
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JMenuBar getLoadGUIJMenuBar() {
	if (ivjLoadGUIJMenuBar == null) {
		try {
			ivjLoadGUIJMenuBar = new JMenuBar();
			ivjLoadGUIJMenuBar.setName("LoadGUIJMenuBar");
			ivjLoadGUIJMenuBar.add(getObjectType());
			ivjLoadGUIJMenuBar.add(getOther());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjLoadGUIJMenuBar;
}
/**
 * Insert the method's description here.
 * Creation date: (10/13/99 10:38:37 PM)
 */
public void getObject() {
	
	ATKB_Object c = new ATKB_Object((String)getATobjectList().getSelectedValue(), RadioSelection, "");
	Thread t = new Thread(new CALoadObject(parent, parent.serverHost, parent.serverPort, c, this));
  	t.start();	
}
/**
 * Return the ObjectGroup property value.
 * @return javax.swing.DefaultListModel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private DefaultListModel getObjectGroup() {
	if (ivjObjectGroup == null) {
		try {
			ivjObjectGroup = new DefaultListModel();
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjObjectGroup;
}
/**
 * Return the ObjectType property value.
 * @return javax.swing.JMenu
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JMenu getObjectType() {
	if (ivjObjectType == null) {
		try {
			ivjObjectType = new JMenu();
			ivjObjectType.setName("ObjectType");
			ivjObjectType.setText("Type");
			ivjObjectType.add(getRadioSystems());
			ivjObjectType.add(getRadioAgents());
			ivjObjectType.add(getRadioConversations());
			ivjObjectType.add(getJSeparator1());			
			ivjObjectType.add(getRadioRoles());
			ivjObjectType.add(getRadioFrameworks());
			ivjObjectType.add(getRadioProperties());
			ivjObjectType.add(getRadioArchitectures());
			ivjObjectType.add(getRadioComponents());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjObjectType;
}
/**
 * Return the Other property value.
 * @return javax.swing.JMenu
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JMenu getOther() {
	if (ivjOther == null) {
		try {
			ivjOther = new JMenu();
			ivjOther.setName("Other");
			ivjOther.setText("Other");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjOther;
}
/**
 * Return the Page1 property value.
 * @return javax.swing.JPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JPanel getPage1() {
	if (ivjPage1 == null) {
		try {
			ivjPage1 = new JPanel();
			ivjPage1.setName("Page1");
			ivjPage1.setLayout(null);
			getPage1().add(getSelectObject(), getSelectObject().getName());
			getPage1().add(getDescriptionField(), getDescriptionField().getName());
			getPage1().add(getDescriptionLabel(), getDescriptionLabel().getName());
			getPage1().add(getGetObject(), getGetObject().getName());
			getPage1().add(getATobjectList(), getATobjectList().getName());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjPage1;
}
/**
 * Return the Page2 property value.
 * @return javax.swing.JPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JPanel getPage2() {
	if (ivjPage2 == null) {
		try {
			ivjPage2 = new JPanel();
			ivjPage2.setName("Page2");
			ivjPage2.setLayout(null);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjPage2;
}
/**
 * Return the RadioAgents property value.
 * @return javax.swing.JRadioButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JRadioButton getRadioAgents() {
	if (ivjRadioAgents == null) {
		try {
			ivjRadioAgents = new JRadioButton();
			ivjRadioAgents.setName("RadioAgents");
			ivjRadioAgents.setText("Agents");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjRadioAgents;
}
/**
 * Return the RadioArchitectures property value.
 * @return javax.swing.JRadioButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JRadioButton getRadioArchitectures() {
	if (ivjRadioArchitectures == null) {
		try {
			ivjRadioArchitectures = new JRadioButton("RadioArchitectures", false);
		//	ivjRadioArchitectures.setName("RadioArchitectures");
			ivjRadioArchitectures.setText("Architectures");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjRadioArchitectures;
}
/**
 * Return the JRadioButton8 property value.
 * @return javax.swing.JRadioButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JRadioButton getRadioComponents() {
	if (ivjRadioComponents == null) {
		try {
			ivjRadioComponents = new JRadioButton();
			ivjRadioComponents.setText("Components");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjRadioComponents;
}
/**
 * Return the RadioConversations property value.
 * @return javax.swing.JRadioButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JRadioButton getRadioConversations() {
	if (ivjRadioConversations == null) {
		try {
			ivjRadioConversations = new JRadioButton("RadioConversations", false);
			ivjRadioConversations.setText("Conversations");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjRadioConversations;
}
/**
 * Return the RadioFrameworks property value.
 * @return javax.swing.JRadioButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JRadioButton getRadioFrameworks() {
	if (ivjRadioFrameworks == null) {
		try {
			ivjRadioFrameworks = new JRadioButton("RadioFrameworks", false);
			//ivjRadioFrameworks.setName("RadioFrameworks");
			ivjRadioFrameworks.setText("Frameworks");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjRadioFrameworks;
}
/**
 * Insert the method's description here.
 * Creation date: (10/11/99 8:53:19 PM)
 * @return javax.swing.ButtonGroup
 */
public ButtonGroup getRadioGroup() {
	return RadioGroup;
}
/**
 * Return the RadioProperties property value.
 * @return javax.swing.JRadioButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JRadioButton getRadioProperties() {
	if (ivjRadioProperties == null) {
		try {
			ivjRadioProperties = new JRadioButton("RadioProperties", false);
		//	ivjRadioProperties.setName("RadioProperties");
			ivjRadioProperties.setText("Properties");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjRadioProperties;
}
/**
 * Return the RadioRoles property value.
 * @return javax.swing.JRadioButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JRadioButton getRadioRoles() {
	if (ivjRadioRoles == null) {
		try {
			ivjRadioRoles = new JRadioButton("RadioRoles", false);
	//		ivjRadioRoles.setName("RadioRoles");
			ivjRadioRoles.setText("Roles");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	
	return ivjRadioRoles;
}
/**
 * Return the RadioSystems property value.
 * @return javax.swing.JRadioButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JRadioButton getRadioSystems() {
	if (ivjRadioSystems == null) {
		try {
			ivjRadioSystems = new JRadioButton("RadioSystems", false);
			ivjRadioSystems.setText("Systems");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjRadioSystems;
}
/**
 * Return the SelectObject property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JButton getSelectObject() {
	if (ivjSelectObject == null) {
		try {
			ivjSelectObject = new JButton();
			ivjSelectObject.setName("SelectObject");
			ivjSelectObject.setText("Use");
			ivjSelectObject.setBounds(259, 164, 85, 27);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjSelectObject;
}
/**
 * Called whenever the part throws an exception.
 * @param exception java.lang.Throwable
 */
private void handleException(java.lang.Throwable exception) {

	/* Uncomment the following lines to print uncaught exceptions to stdout */
	// System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	// exception.printStackTrace(System.out);
}
/**
 * Initializes connections
 * @exception java.lang.Exception The exception description.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initConnections() throws java.lang.Exception {
	// user code begin {1}
	// user code end
//	getATobjectList().addListSelectionListener(ivjPage1);
	getRadioRoles().addActionListener(ivjEventHandler);
	getRadioFrameworks().addActionListener(ivjEventHandler);
	getRadioConversations().addActionListener(ivjEventHandler);
	getRadioAgents().addActionListener(ivjEventHandler);
	getRadioSystems().addActionListener(ivjEventHandler);
	getRadioArchitectures().addActionListener(ivjEventHandler);
	getRadioComponents().addActionListener(ivjEventHandler);	
	getGetObject().addActionListener(ivjEventHandler);
	getSelectObject().addActionListener(ivjEventHandler);
}
/**
 * Initialize the class.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initialize() {
	try {
		// user code begin {1}
		// user code end
		setName("LoadGUI");
		setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		setSize(602, 353);
		setJMenuBar(getLoadGUIJMenuBar());
		setContentPane(getJFrameContentPane());
		initConnections();
	} catch (java.lang.Throwable ivjExc) {
		handleException(ivjExc);
	}
	// user code begin {2}
	// user code end
}
/**
 * main entrypoint - starts the part when it is run as an application
 * @param args java.lang.String[]
 */
public static void main(java.lang.String[] args) {
	try {
		LoadGUI aLoadGUI;
		aLoadGUI = new LoadGUI();
		aLoadGUI.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				System.exit(0);
			};
		});
		aLoadGUI.setRadioGroup();
	//	aLoadGUI.setVisible(true);
	} catch (Throwable exception) {
		System.err.println("Exception occurred in main() of javax.swing.JFrame");
		exception.printStackTrace(System.out);
	}
}
/**
 * Insert the method's description here.
 * Creation date: (10/14/99 2:24:35 PM)
 */
public void receiveLoad(ATKB_Object target) {
	String type = target.getotype();
	MAML  = target.getMAML();
	if (type.equals("system.ATconversation")) {
		//input null b/c ATconversation needs a system to create itself,
		//but this doesn't have one.  -hopefully this will work...
		ATconversation c = new ATconversation(Editor.ATeditor.version,MAML,null);
		getDescriptionField().setText(c.getDescription());
	}
	if (type.equals("system.ATagent")) {
		ATagent a = new ATagent(Editor.ATeditor.version,MAML, null);
		getDescriptionField().setText(a.getDescription());
	}
	if (type.equals("system.ATsystem")) {
		ATsystem s = new ATsystem(Editor.ATeditor.version,MAML);
		getDescriptionField().setText(s.getDescription());
//		hold=(ATobject)c;
	}
	if (type.equals("system.ATrole")) {
		//ATrole r = new ATrole(Editor.ATeditor.version,MAML);
		//getDescriptionField().setText(r.getDescription());
	}
	if (type.equals("system.ATarchitecture")) {
		ATarchitecture arch = new ATarchitecture(Editor.ATeditor.version,MAML,null);
		getDescriptionField().setText(arch.getDescription());
	}
	if (type.equals("system.ATagentComponent")) {
		ATagentComponent cmpt = new ATagentComponent(Editor.ATeditor.version,MAML,null);
		getDescriptionField().setText(cmpt.getDescription());
	}
	if (type.equals("system.ATframework")) {
		//ATframework f = new ATframework(MAML);
		//getDescriptionField().setText(f.getDescription());
	}		
}
/**
 * Insert the method's description here.
 * Creation date: (10/11/99 10:35:57 PM)
 */
public void returnObject() {
if (type.equals("system.ATconversation")) {
	//input null b/c conversation needs a system to create itself,
	//hopefully this will work...
	((ATconversation)hold).integrateKBInfo(MAML,null);
}
if (type.equals("system.ATagent")) {
	((ATagent)hold).integrateKBInfo(MAML, null);
}
if (type.equals("system.ATsystem")) {
	((ATsystem)hold).reConstruct(MAML);
}
if (type.equals("system.ATagentComponent")) {
	((ATagentComponent)hold).integrateKBInfo(MAML,null);
}
if (type.equals("system.ATarchitecture")) {
	((ATarchitecture)hold).integrateKBInfo(MAML,null);
}
}
/**
 * Insert the method's description here.
 * Creation date: (10/11/99 10:35:57 PM)
 */
public void setList(Set s) {
	
//Somehow parse the enumeration of key strings into the ListField	

	  getObjectGroup().clear();
	  for(Iterator i=s.iterator(); i.hasNext();) {
	  	getATobjectList().setModel(getObjectGroup());
	  	getObjectGroup().addElement((String)i.next());
	  }
	
}
/**
 * Insert the method's description here.
 * Creation date: (10/11/99 8:53:19 PM)
 * @param newRadioGroup javax.swing.ButtonGroup
 */
public final void setRadioGroup() {
	final ButtonGroup RadioGroup = new ButtonGroup();
	RadioGroup.add(getRadioRoles());
	RadioGroup.add(getRadioFrameworks());
	RadioGroup.add(getRadioProperties());
	RadioGroup.add(getRadioArchitectures());
	RadioGroup.add(getRadioSystems());
	RadioGroup.add(getRadioAgents());
	RadioGroup.add(getRadioConversations());
	RadioGroup.add(getRadioComponents());
}
}
