package system;

/**
 * Insert the type's description here.
 * Creation date: (6/16/00 1:42:14 PM)
 * @author: 
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
 import java.awt.*;
public class ATmessageGRFX {
	ATrole2GRFX start, end;
	int x1, x2, y;
	String name;
	int x1f, y1f, y2f;
/**
 * ATmessageGRFX constructor comment.
 */
public ATmessageGRFX() {
	super();
}
/**
 * ATmessageGRFX constructor comment.
 */
public ATmessageGRFX(ATmessageGRFX cp) {
	super();
}
/**
 * Insert the method's description here.
 * Creation date: (6/16/00 1:55:42 PM)
 */
public void arrow() {
	if(x2>x1){
		x1f = x2 - 10;
	} else {
		x1f = x2+10;
	}
	y1f = y - 5;
	y2f = y + 5;
}
/**
 * Insert the method's description here.
 * Creation date: (6/19/00 1:45:17 PM)
 * @return boolean
 * @param x int
 * @param y int
 */
public boolean checkSelected(int x, int y) {
	int diff = 50;
	if((x<x2 && x>x1)||(x>x2 && x<x1)){
		diff = y-this.y;
		if(diff<8 && diff>-8){
			return true;
		}
	}
	return false;
}
/**
 * Insert the method's description here.
 * Creation date: (6/20/00 11:31:24 AM)
 */
public void deleteMe() {
	start.deleteMessage(this);
	end.deleteMessage(this);
}
/**
 * Insert the method's description here.
 * Creation date: (6/16/00 1:45:57 PM)
 */
public void draw(Graphics g) {
	Font f = g.getFont();	
	//FontMetrics fm = Toolkit.getDefaultToolkit().getFontMetrics(f);
	FontMetrics fm = g.getFontMetrics(); // SAD Change - deprecated fix???
	int textWidth = fm.stringWidth(name);
	
	g.setColor(Color.red);
	g.drawLine(x1,y,x2,y);
	g.setColor(Color.black);
	g.drawLine(x2,y,x1f,y1f);
	g.drawLine(x2,y,x1f,y2f);
	g.drawString(name, (x1+x2)/2 - textWidth/2, y-5);
	}
/**
 * Insert the method's description here.
 * Creation date: (6/16/00 1:45:57 PM)
 */
public void drawSelected(Graphics g) {
	
	g.setColor(Color.yellow);
	g.drawLine(x1,y-1,x2,y-1);
	g.drawLine(x1,y+1,x2,y+1);
	
	}
/**
 * Insert the method's description here.
 * Creation date: (6/19/00 1:56:34 PM)
 * @param dy int
 */
public void move(int dy) {
	y = dy;
	if(y < start.base()) y = start.base();
	if(y > start.tip()) y = start.tip();
	
	arrow();
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 12:57:22 PM)
 * @param start system.ATrole2GRFX
 * @param end system.ATrole2GRFX
 */
public void refresh(ATrole2GRFX start, ATrole2GRFX end) {
	this.start = start;
	this.end = end;
	x1 = start.center_x;
	x2 = end.center_x;
	y = start.y2+30;
	arrow();
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 12:57:22 PM)
 * @param start system.ATrole2GRFX
 * @param end system.ATrole2GRFX
 */
public void refresh(ATrole2GRFX start, ATrole2GRFX end, int n) {
	this.start = start;
	this.end = end;
	x1 = start.center_x;
	x2 = end.center_x;
	y = start.y2+30+(n-1)*15;
	arrow();
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 1:00:41 PM)
 * @param h int
 */
public void setHeight(int h) {
	y=h;
	arrow();
}
/**
 * Insert the method's description here.
 * Creation date: (6/19/00 12:01:45 PM)
 * @param n java.lang.String
 */
public void setName(String n) {
	name = n;
	}
}
